/*
 * $Id: ChangeLog.014,v 1.1 2003/02/06 05:27:44 walito Exp $
 */

/* Use this format for the entry headers:
   YYYY-MM-DD HH:MM UTC[-|+]hhmm Your Full Name <your_email@address>
   For example:
   2002-12-01 23:12 UTC+0100 Foo Bar <foo.bar@foobar.org>
*/

2003-02-05 19:20 UTC+0100 Giancarlo Niccolai <gian@niccolai.ws>
  * source/rtl/regex.c
    + Added HB_RegexComp( cPattern, [bCaseSens [, bNewLine]] ) --> REGEX
      function that pre-compiles a pattern. A compiled REGEX can be then
      used many times in HB_Regex() to save time. On error ( i.e. wrong
      regex), it returns NIL. Case sensitivity is TRUE by default,
      and if bNewLine and true then the multiline pattern matching is
      activated ( '^' and '$' will match begin and end of the line, and not
      begin and end of the string).
    * HB_Regex( cPattern, cString, [bCaseSens, [, bNewLine]] ) --> aMatch
      Now cPattern can be a pre-compiled REGEX or a regular expression
      pattern. bCaseSens and bNewLine are ignored if cPattern is pre
      compiled.

  + tests/regex.prg
    + Added a demo for HB_Regex

2003-02-04 15:51 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/rtl/errorsys.prg
    - Removed call to TraceLog()

  * source/rtl/tgetlist.prg
    * Minor formating.

  * source/rtl/trace.c
    * Commented Error generation on failure to create "trace.log" file.

  * tests/test.prg
    - Removed unneeded line.

2003-02-03 21:51 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/pp/ppcore.c
    * Additional fix to '.' support in md_strAt().

  * tests/pp.prg
    * Few Fixes in CompileRule().

2003-02-03 18:25 UTC-0300 Walter Negro <anegro@overnet.com.ar>
  * contrib/mysql/tmysql.prg
    ! Fixed typo in variable.
      Reported by Gianluca Piemonte

2003-02-03 21:24 UTC+0100 Giancarlo Niccolai <gian@niccolai.ws>
  * source/vm/inet.c
    * More optimizations and tests in timeout control

  * source/rtl/regex.c
    * Added HB_Regex( cRegex, cString, [, bCase] )--> ARRAY. On failure, it
      returns  NIL, while on success it returns an array of successful
      matches.
      The first element is the whole match found, while the others
      (2 to end) are the subgroups matches. Eg:
      HB_Regex( "a(.)c", "a string abc here" ) would return
      { "abc", "b" }.
      Match is case insensitive by default, unless you specify .T. as third
      parameter.

      This is an experimental grammar and will probably be changed in the
      future.

2003-02-03 10:34 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/pp/ppcore.c
    * Additional fix to '.' support in md_strAt()

2003-02-03 11:05 UTC-0300 Walter Negro <anegro@overnet.com.ar>
  * source/rtl/tbrowse.prg
    ! Fix display with border active.
      Reported by Larry Sevilla.

2003-02-03 09:10 UTC-0300 Marcelo Lombardo <lombardo@uol.com.br>
  * source/rtl/dbdelim.prg
    ! Fixed default value in __dbDelim() parameters

2003-02-03 07:50 UTC+0100 Giancarlo Niccolai <gian@niccolai.ws>
  * source/vm/inet.c
    ! InetRecv() and InetRecvAll() were not returning 0 when having
      a timeout. Fixed.

2003-02-03 02:25 UTC-0300 Walter Negro <anegro@overnet.com.ar>
  * source/rtl/ttable.prg
    % Optimizations with FOR-EACH and ADEL/ASIZE suggested by Andi Jahja.

2003-02-03 02:15 UTC-0300 Walter Negro <anegro@overnet.com.ar>
  * contrib/make_b32.bat
  * contrib/Makefile
  * contrib/makefile.bc
  * contrib/mysql.c
  * contrib/mysql.ch
  * contrib/tmysql.prg
  * contrib/dbf2mysql.prg
  * contrib/tsqlbrw.prg
  * contrib/test.prg          // test with comments in english
  * contrib/testes.prg        // test with comments in spanish
  * contrib/animal.dbf
  * contrib/readme.txt
    * Classes for access to MySQL server from xHarbour.
      Original from Harbour contributions with several
      optimizations, code depuration and improvements.

2003-02-02 22:50 UTC-0200 Luiz Rafael Culik <culikr@uol.com.br>
  * contrib/rdd_ads/adsfunc.c
    + Added functions for Transactions

2003-02-02 03:10 UTC+0100 Giancarlo Niccolai <gian@niccolai.ws>
  * source/rtl/gtQTc/gtQTc.cpp
  * source/rtl/gtQTc/qtconsoledoc.cpp
  * source/rtl/gtQTc/qtconsoledoc.h
  * source/rtl/gtQTc/qtconsoleview.cpp
  * source/rtl/gtQTc/qtconsoleview.h
    + Cursor can now turned ON/OFF
    * Optimizations in various places

2003-02-02 03:10 UTC+0100 Giancarlo Niccolai <gian@niccolai.ws>
  * source/rtl/gtQTc/gtQTc.cpp
  * source/rtl/gtQTc/qtconsole.cpp
  * source/rtl/gtQTc/qtconsole.h
  * source/rtl/gtQTc/qtconsoledoc.cpp
  * source/rtl/gtQTc/qtconsoledoc.h
  * source/rtl/gtQTc/qtconsoleview.cpp
  * source/rtl/gtQTc/qtconsoleview.h
    + Added input support (pretty compelte I think)
    ! fixed box support
    ! Background is cleanly deleted
    + Scroll is now able to clean an area of the screen

  * tests/mtgc.prg
    * working tests.

  * tests/qttest.prg
    Added test of get/read (working :-)

2003-02-01 20:01 UTC+0100 Patrick Mast <patrick@winfakt.com>
  * source/rtl/tpopup.prg
    ! Fixed nDif warnings

2003-02-01 16:06 UTC+0100 Giancarlo Niccolai <gian@niccolai.ws>
  ! source/vm/thread.c
    ! Fixed the possible deadlock at thread termination when GC
      is involved.

2003-02-01 12:10 UTC-0200 Luiz Rafael Culik <culikr@uol.com.br>
  * source/rdd/dbcmd.c
    ! Last change fix linux problem with RLOCK() but break windows.
      Fix now to work properly on both system

2003-02-01 13:46 UTC+0100 Giancarlo Niccolai <gian@niccolai.ws>
  ! source/vm/thread.c
    ! Fixed an error introduced by my on last optimization tests.
      Now it seems that MT is pretty stable also under GC. There
      are still minor problems, but now it goes great.

  % source/vm/estack.c
    % Optimized MT programs, so that estack calls hb_threadGetCurrentStack()
      only once per function.

  * tests/mtgc.prg
    * cleaned up the code and added an header.

  + doc/thread.txt
    + Thread api reference: functions in thread.c and their description.


2003-01-31 18:00 UTC-0300 Walter Negro <anegro@overnet.com.ar>
  * source/rtl/tpopup.prg
  * source/rtl/ttopbar.prg
    ! Fix display problems in child popup menu.
      Reported by Gianluca Piemonte.

2003-01-31 20:40 UTC+0100 Giancarlo Niccolai <gian@niccolai.ws>
  * source/vm/thread.c
    * Prototype of Subscribe() and SubscribeAll() changed. Now there
      is an addititonal parameter returning the status in timed out
      requests:
      Subscribe( Mutex[, nMillisec[, @bStatus]] ) --> Any
      On exit, bStatus will be false if timeout has expired, and true
      if notification is issued.

  * tests/mtcomplex.prg
    * Minor style fixes

  * tests/inetto.prg
    * using the new Subscribe() grammar in timeout wait.

2003-01-31 20:15 UTC+0100 Marek Paliwoda <paliwoda@inetia.pl>
  * source/rtl/gtsln/mousesln.c
    * Some cleanup related to last mousesln.c fixes

2003-01-31 19:40 UTC+0100 Giancarlo Niccolai <gian@niccolai.ws>
  * source/vm/inet.c
    ! fixed a potential problem in InetRecv().

2003-01-31 01:06 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/rtl/objfunc.prg
    + Added new __objDerivedDiff( oObj, oBase, nScope )

2003-01-31 01:30 UTC-0300 Walter Negro <anegro@overnet.com.ar>
  * source/debug/dbgtwin.prg
    * Optimizations with SWITCH-CASE

2003-01-29 23:40 UTC-0300 Walter Negro <anegro@overnet.com.ar>
  * source/lang/msges.c
    * turn sub-section Texts to spanish.

2003-01-29 23:25 UTC-0300 Walter Negro <anegro@overnet.com.ar>
  * source/debug/dbgtarr.prg
  * source/debug/dbgtmenu.prg
  * source/debug/dbgtobj.prg
  * source/debug/dbgwa.prg
  * source/debug/debugger.prg
    * Optimizations with SWITCH-CASE

2003-01-29 23:00 UTC-0200 Luiz Rafael Culik <culikr@uol.com.br>
  * source/rtl/tget.prg
    ! Fixed problem on Delete() method that was not indicating that the Buffer has
      changes to Updated() function Reported by Sidney Junior

2003-01-30 01:41 UTC+0100 Giancarlo Niccolai <gian@niccolai.ws>
  * makefile.bc
  * makefile.nt
  * makefile.vc
  * source/rtl/Makefile
  * source/rtl/hbrandom.c
    + Added HB_Random() func:
      HB_Random()--> nVar ( 0 <= nVar <= 1 )
      HB_Random( nCeil )--> nVar ( 0 <= nVar <= nCeil )
      ( or if nCeil < 0:  nCeil <= nVar <= 0 )
      HB_Random( nFloor, nCeil )--> nVar ( nFloor <= nVar <= nCeil )
      ( the smaller var is taken as floor).

  * tests/random.prg
    + Added a demo of the random function

  * source/rtl/gtQTc/filenew.xpm
  * source/rtl/gtQTc/fileopen.xpm
  * source/rtl/gtQTc/filesave.xpm
  * source/rtl/gtQTc/gtQTc.cpp
  * source/rtl/gtQTc/gtQTc.h
  * source/rtl/gtQTc/mouseQTc.c
  * source/rtl/gtQTc/qtconsole.cpp
  * source/rtl/gtQTc/qtconsole.h
  * source/rtl/gtQTc/qtconsoledoc.cpp
  * source/rtl/gtQTc/qtconsoledoc.h
  * source/rtl/gtQTc/qtconsoleview.cpp
  * source/rtl/gtQTc/qtconsoleview.h
    + Added gtQTc: a frame buffer (terminal emulator) in a window
      using GPL QT libraries. This is HIGLY experimental and in
      the first developement phases. I need the help of the whole
      community (at least the linux part) here.

  * config/linux/global.cf
    + added experimental support for gtQTc that is compiled only
      on linux, if HB_GT_LIB=gtQTc (respect case!)

  * tests/Makefile
    ! Makefile has now a comment and it is capable to compile examples
      in gtQT mode if needed.

  * tests/qttest.prg
    + Added a test of a gtQTc complaint application.

2003-01-29 22:35 UTC-0200 Luiz Rafael Culik <culikr@uol.com.br>
  * source/rtl/gtsln/mousesln.c
    ! Some changes to work properly on xTerm and Remote terminals(Thanks for Marek for Some Help)

2003-01-30 04:30 UTC+0700 Andi Jahja <andijahja@harbour-id.net>
  Again, function declaration matching among those in header files and function
  bodies to enable creation of MSVC DLL.
  * include/hbapi.h
  * include/hbapifs.h
  * include/hbtrace.h
  * source/common/hbffind.c
  * source/common/hbtrace.c
  * source/rtl/datec.c
  * source/rtl/dates.c
  * source/rtl/langapi.c

2003-01-28 15:11 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/pp/ppcore.c
    ! Fixed a typo.

  * source/rtl/cstr.prg
    ! Fixed 2 missing EXIT in recent optimization to SWITCH.

  * source/vm/hvm.c
    * Minor formatting.

2003-01-29 19:35 UTC-0200 Luiz Rafael Culik <culikr@uol.com.br>
  * doc/en/dbsdf.txt
    doc/en/dbdelim.txt
    ! Minor changes
  * doc/en/rddmisc.txt
    + Doc For Use and Index Commands
  + doc/en/defines.txt
    + Docs for #error,#command,#xcommand and the other preprocessor commands

2003-01-28 20:00 UTC-0200 Luiz Rafael Culik <culikr@uol.com.br>
  * source/rdd/dbcmd.c
    ! Fixed initialization of dbLockInfo.itmRecID member to -1 on RLOCK() and FLOCK() functions;
      With RDDADS on Linux this cause an GPF on adslock() member of rddads when trying to compare
      a trash with 0

2003-01-28 08:12 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/pp/ppcore.c
    ! Minor fixed to add numeric support to recent fix to md_strAt() when searching for '.'

2003-01-28 00:27 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/pp/ppcore.c
    ! Minor fixed to recent fix to md_strAt() when searching for '.'

2003-01-27 00:02 UTC+0100 Giancarlo Niccolai <gian@niccolai.ws>
  * source/vm/thread.c
    ! Fixed a time slice rollover bug that could have caused miswaits in
      Subscribe() and SubscribeAll() timed waits under linux.
    ! Now the queue of notified object is FIFO instead of LIFO (queue
      instead of stack) as it should presumibily be.
    ! Fixed minor leftovers in SubscribeNow() and NotifyAll() functions


2003-01-27 22:30 UTC+0100 Giancarlo Niccolai <gian@niccolai.ws>
  * include/thread.h
  * source/vm/thread.c
    ! Mutex condition-and-wait has moved from macro to function on linux.
    ! Detaching threads just before terminatio on linux to avoid memory leaks
    + Added notification object stack (this resolves the subscribe/notify
      problem when having multiple notify before one thread subscribes).

  * tests/Makefile
    ! Better usage of HB_MT flag

  * tests/inetto.prg
  * tests/mtgc.prg
    * Work in progress and tests

2003-01-27 10:35 UTC-0200 Luiz Rafael Culik <culikr@uol.com.br>
  * utils/hbmake/hbmake.prg
    * Added support for linking the correct HVMxxx.obj

2003-01-26 21:27 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/rtl/color53.prg
    + Added missing declaration for variable cToken

  * source/rtl/persist.prg
    + Added missing #include common.ch

2003-01-27 01:45 UTC-0300 Walter Negro <anegro@overnet.com.ar>
  * makefile.bc
  * makefile.vc
  * hrbdll.bc
  * hrbdll.vc
    + Add arrayblk.prg, color53.prg, mssgline.prg

2003-01-27 01:30 UTC-0300 Walter Negro <anegro@overnet.com.ar>
  * source/vm/hvm.c
    + Add support for cancel with Ctrl-Break
    + Add support to call to debug in an infinite or very big loop.

2003-01-27 01:27 UTC-0300 Walter Negro <anegro@overnet.com.ar>
  * source/rtl/Makefile
    + Add arrayblk.prg, color53.prg, mssgline.prg

2003-01-27 01:25 UTC-0300 Walter Negro <anegro@overnet.com.ar>
  * include/hblang.ch
    + Add constant from hbapilng.h

2003-01-27 01:20 UTC-0300 Walter Negro <anegro@overnet.com.ar>
  * source/rtl/inkey.c
  * include/hbapigt.h
    + Support for KEYBOARD command independent of SET TYPEAHEAD
    + Add function hb_setInkeyLast for support to SETLASTKEY function of
      CT library.

2003-01-27 01:15 UTC-0300 Walter Negro <anegro@overnet.com.ar>
  * source/rtl/objfunc.prg
    + Add function for create Access & Assign method for simulate
      controled instance variable.

2003-01-27 01:12 UTC-0300 Walter Negro <anegro@overnet.com.ar>
  * source/rtl/mssgline.prg
    + Message Line Class for Get and Menu System.
      Implemented by Larry Sevilla.

2003-01-27 01:10 UTC-0300 Walter Negro <anegro@overnet.com.ar>
  * source/rtl/color53.prg
    + Undocumented functions of treatment of color. Used in Get and Menu.

2003-01-27 01:05 UTC-0300 Walter Negro <anegro@overnet.com.ar>
  * source/rtl/arrayblk.prg
    + Add function HB_ArrayBlk( array, index ).
      Generate a codeblock to access to a position of the array.

2003-01-27 01:00 UTC-0300 Walter Negro <anegro@overnet.com.ar>
  * source/rtl/tmenuitm.prg
  * source/rtl/tpopup.prg
  * source/rtl/ttopbar.prg
    * More readable code
    + Add routines, simulating Menusys of Clip53
      Modifications maked by Larry Sevilla

2003-01-27 00:55 UTC-0300 Walter Negro <anegro@overnet.com.ar>
  * source/rtl/getsys.prg
  * source/rtl/tgetlist.prg
    + Add support for Menu system
    * enclosed Clip53 compatible routines with HB_COMPAT_C53
    * Line Message was implemented as object.
    * Modified ReadFormat & __SetFormat routines
      Modifications maked by Larry Sevilla

2003-01-27 00:45 UTC-0300 Walter Negro <anegro@overnet.com.ar>
  * source/rtl/tget.prg
    * Optimizations with SWITCH and FOR EACH
    + Support for press YES/NO key in national languages for logicals get.

2003-01-27 00:30 UTC-0300 Walter Negro <anegro@overnet.com.ar>
   * source/rtl/achoice.prg
   * source/rtl/alert.prg
   * source/rtl/browse.prg
   * source/rtl/cstr.prg
   * source/rtl/dbdelim.prg
   * source/rtl/dbedit.prg
   * source/rtl/dbsdf.prg
   * source/rtl/errorsys.prg
   * source/rtl/listbox.prg
   * source/rtl/memoedit.prg
   * source/rtl/menuto.prg
   * source/rtl/persist.prg
   * source/rtl/profiler.prg
   * source/rtl/radiogrp.prg
   * source/rtl/readkey.prg
   * source/rtl/setfunc.prg
   * source/rtl/tbrowse.prg
   * source/rtl/teditor.prg
   * source/rtl/treport.prg
   * source/rtl/ttable.prg
     * Optimizations with SWITCH-CASE

2003-01-26 05:50 UTC+0300 Phil Krylov <phil@mail.ru>
  * include/hbdefs.h
    + Added HB_PCODE_MKDOUBLE macro to handle little-endian IEEE 754 double
      values on big-endian machines.
    + Added HB_USHORT_FROM_LE, HB_ULONG_FROM_LE, HB_USHORT_TO_LE, and
      HB_ULONG_TO_LE macros.
  * source/compiler/genc.c
  * source/compiler/harbour.c
  * source/vm/hvm.c
  * source/vm/macro.c
    ! Made HB_P_PUSHDOUBLE work properly on big-endian machines.
  * source/rdd/dbf1.c
    ! Fixed to work properly on big-endian machines.
  * source/vm/thread.c
    ! Fixed Darwin usleep() call in THREADSLEEP().

2003-01-25 18:40 UTC-0200 Luiz Rafael Culik <culikr@uol.com.br>
  * utils/hbmake/hbmake.prg
    * Minor Fix
  * source/common/hbffind.c
    % Fixed problem on hb_fsFindFill() on Unix platform.(directory() function
      was failing when directory('source/spec') is used(spec any valid filename or wild card)
      The date was returning as year 1935 and file size was  wrong
    + Added char   szRootDir[ _POSIX_PATH_MAX + 1 ]; member to HB_FFIND_INFO
      structure for unix Platform
  - doc/switch.txt
  - doc/try.txt
  + doc/en/switch.txt
  + doc/en/try.txt
    + Added files rewritten for hbdoc processing.
  * doc/en/set.txt
    * Added description to _SET_FILECASE,_SET_DIRCASE,_SET_DIRSEPARATOR inside set Function

2003-01-24 17:45 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * include/hbcomp.h
    + Added #define HB_MAX_SWITCHES 16

  * source/compiler/harbour.sly
    + Added support for upto HB_MAX_SWITCHES nested SWITCH control flows.

  * tests/switch.prg
    * Minor revisions.

  + xdiff.txt
    + Added document describing xHarbour Extensions.

  + doc/switch.txt
  + doc/try.txt
    + Added documentation files.

2003-01-24 01:52 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * include/hbpcode.h
  * source/compiler/genc.c
  * source/compiler/harbour.slx
  * source/compiler/harbour.sly
  * source/compiler/hbfix.c
  * source/compiler/hbpcode.c
  * source/vm/hvm.c
    + Added support for new Syntax:

       SWITCH <Exp>
          CASE <Constant>
             ...
             [BREAK]

           [DEFAULT]
             ...
       END

    /*
       NOTE: This sysntax is modeled after the C 'switch' flow control.
             It offers great spead benefit [30-300%] over DO CASE flow
             control, but is restricted to comparing only constants.
             Constants maybe: Integers, Longs, or Single Character
             Strings [much like in C]

       WARNING: Those NOT familiar with the C switch flow control, SHOULD
                understand that UNLIKE DO CASE, you MUST explictly use
                the BREAK statement or else logic will FALL THROUGH to the
                NEXT CASE, until stoped at a BREAK, or DEFAULT, or END
                statements.

                At first this might seem VERY ODD, but it provides great
                flexibility exactly like the C model.

                SEE tests/switch.prg to learn how the FALL-THROUGH Logic
                works.
     */

  * include/hberrors.h
    + Added #define HB_COMP_ERR_INVALID_CONSTANT            59

  * source/compiler/hbgenerr.c
    + Added new error: "Invalid SWITCH Constant \'%s\'."

2003-01-23 15:36 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/compiler/harbour.slx
    * Changed 1 instance of explicit ascii code usage to 'A' and 'Z' instead.

  * source/macro/macro.slx
    * Minor revison to debug message.

2003-01-24 04:40 UTC+0700 Andi Jahja <andijahja@harbour-id.net>
  * source/vm/hvm.c
    ! add $ifdef __PROFILER__ #endif to activate profiler.
      Note:
       Disabling this feature make application a bit faster. It is recommended
       for final application.
  * makefile.bc
    + add creation of hvm.obj, hvmmt.obj, hvmgui.obj, hvmguimt.obj.
      Purpose/Usage:
       hvm.obj -> console mode application ST
       hvmmt.obj -> console application MT
       hvmgui.obj -> GUI mode application ST
       hvmguimt.obj -> GUI application MT
      Note:
       These four object files are to be located in LIB_DIR. Make sure you
       link appropriate hvm*.obj __BEFORE__ hvm.lib during creating application.

2003-01-22 21:01 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/compiler/simplex.c
    - Removed bStart from RESET_LEX()
    + Added bIgnoreWords to RESET_LEX().
    + Added 1 missing RESET_LEX().

2003-01-22 19:25 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/pp/ppcore.c
    ! Fixed bug in md_strAt() when searching for '.'

  * source/vm/hvm.c
    + Added support for HB_GUI define, to exclude KB polling for Alt+C.

2003-01-21 07:30 UTC+0300 Phil Krylov <phil@mail.ru>
  * make_drw.sh
    * Allow building with gtcrs.
  * include/hbdefs.h
    + Added HB_PCODE_MKSHORT, HB_PCODE_MKUSHORT, HB_PCODE_LONG,
      HB_PCODE_MKULONG, HB_PCODE_MK24BIT macros to handle platform-independent
      little-endian pcode on big-endian machines
  * source/compiler/genc.c
  * source/compiler/hbpcode.c
  * source/vm/hvm.c
    ! Use HB_PCODE_MK* to access pcode all over the place. It fixes most
      Darwin bugs and should improve performance a little on little-endian
      platforms too (as I think).
  * source/vm/codebloc.c
    ! Use HB_PCODE_MKUSHORT( pLocalPosTable++ ) in hb_codeblockNew(). This
      is done with an assumption that pLocalPosTable is always located inside
      pcode.
  * tests/Makefile
    * Adjusted Darwin configuration

2003-01-20 06:10 UTC+0700 Andi Jahja <andijahja@harbour-id.net>
  * source/rtl/transfrm.c
    ! fixed bug reported by Vic< vic@guerra.com.mx>
      -> now using hb_retclenAdopt() instead of hb_retclen()

2003-01-20 04:40 UTC+0700 Andi Jahja <andijahja@harbour-id.net>
  * include/hbfast.h
  * include/hbapierr.h
  * include/hbdate.h
  * include/hbapilng.h
  * include/hbapirdd.h
  * source/rdd/dbcmd.c
  * source/vm/arrays.c
  * source/vm/errorapi.c
  * source/rtl/filesys.c
  * source/common/hbstr.c
    ! matching function declaration in header files with those
      of the function bodies'. Now that MSVC DLL works again.
  * hrbdll.bc
  * hrbdll.vc
    ! Modification to include flags: -DHB_NO_DEFAULT_API_MACROS -DHB_NO_DEFAULT_STACK_MACROS

2003-01-17 16:58 UTC-0300 Horacio Roldan <harbour_ar@yahoo.com.ar>
  * include/hbapirdd.h
  * include/hbrddcdx.h
  * source/rdd/dbfcdx/dbfcdx2.h
  * source/rdd/dbfcdx/dbfcdx1.c
    * INDEX command:
      ! added support for relations in the index key (or conditions).
        Note that if the dbf has relations the indexing is a bit slower,
        but it works.
      ! fixed support for deleted() in index expresion or conditions
      * some speed optimizations
      + added support for "INDEX ... WHILE cond"
      + added support for "INDEX ... REST"
      + added support for "INDEX ... NEXT n"
      + added support for "INDEX ... RECORD n"
      + added support for "INDEX ... USECURRENT"
      ! fixed GPF in dbOrderInfo

2003-01-17 15:10 UTC+0300 Phil Krylov <phil@mail.ru>
  * make_drw.sh
    * Changed the defaults for HB_*_INSTALL to those given in make_gnu.sh; and
      just call make_gnu.sh after configuring Darwin-specific variables
  * config/darwin/global.cf
    ! Fixed three typos in MT-related lines
  * include/inet.h
    ! Fixed a typo in header
    + Added "#define socklen_t int" on Darwin
  * source/vm/inet.c
    + Added "#include <sys/time.h>" for struct timeval on BSD+Darwin
  * source/rdd/dbfcdx/Makefile
  * source/rdd/dbfntx/Makefile
    ! Changed LIBNAME=dbf{cdx,ntx}mt to MT_LIBNAME=dbf{cdx,ntx}mt. Am I wrong?
  * tests/Makefile
    + Added Darwin configuration

2003-01-17 00:28 UTC+0100 Francesco Saverio Giudice <info@fsgiudice.com>
  * tests/mtgc.prg
    - commented out HB_GCALL() function not more needed
  + tests/bldtest.bat
    + added bldtest.bat that call bin/bld.bat with the right path defined
      for that people that haven't defined HB_* path

2003-01-16 12:40 UTC-0300 Walter Negro <anegro@overnet.com.ar>
  * include/thread.h
    * #ifdef for void compile in non-multithreading compilations.
  * source/compiler/harbour.c
    * Initialization of Unions in gcc requires brakets.
    * Update of quantity and type of parameters of some functions.
  * source/compiler/hbusage.c
    * another serious omission ;-)

2002-01-16 13:30 UTC-0300 Walter Negro <anegro@overnet.com.ar>
  * source/rtl/file.c
    * hb_fsFile() support for FILE() function.
      Set FERROR() to 0 this is the behavior of Cl*pper.
  * source/rtl/filesys.c
    * Set DOS compatible errors to errno var for gcc compilers.
  * source/rtl/tbrowse.prg
  * source/rtl/tget.prg
    % Minor optimization and code cleaning

2002-01-16 13:55 UTC-0300 Walter Negro <anegro@overnet.com.ar>
  * utils/hbtest/rt_file.prg
    * update values of FERROR() in call to FILE()
  * utils/hbtest/rt_math.prg
    * update rounded values in floating point operations.

2003-01-15 17:29 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * include/hbcomp.h
  * source/compiler/harbour.c
  * source/compiler/harbour.sly
  * source/compiler/hbpcode.c
    * Removed usage of UN named union as it's not supported by older versions of gcc.

2003-01-15 21:20 UTC+0100 Giancarlo Niccolai <gian@niccolai.ws>
  * samples/sitesvr/sitesvr.prg
    ! The incoming connection was not served in a separate thread
    ! Fixed an error when adding a new page

2003-01-15 17:11 UTC-0300 Horacio Roldan <harbour_ar@yahoo.com.ar>
  * source/rdd/dbfcdx/dbfcdx2.h
  * source/rdd/dbfcdx/dbfcdx1.c
    * In INDEX command:
      ! fixed index creation error, when the preexistent tag has
        an invalid key
      ! structural index is kept always open
      + added support for INDEX ... ADDITIVE
      ! fixed when recreating an existing tag of an open index
      * work in progress: support for temporary indexes

2003-01-15 12:00 UTC+0700 Andi Jahja <andijahja@harbour-id.net>
  * source/compiler/hbusage.c
    ! fix serious bug on header file: 2002 -> 2003 :-)

2003-01-14 23:30 UTC+0100 Giancarlo Niccolai <gian@niccolai.ws>
  * source/vm/inet.c
    * commented out all garbage collecting stuff; now inet socket
      collection can AND must be done at PRG level, since Inet
      pbjects could and generally are shared among threads.
    ! Connecting functions fixed under windows.

  * include/thread.h
  * source/vm/thread.c
    * hb_threadCreateContext() accepts thread ID parameter
      and returns the created context.
    * Now hb_threadDestroyContext() and hb_threadGetContext()
      accept a parameter (desired thraed id); removed
      hb_destroyContextFromHandle() for stake of simplicity.
    * under Windows, use just thread ID to identify threads;
      Handle is saved in the context but just to be used when
      managing the thread
    * in StartThread(), removed polling loop waiting for handle
      (now given in context creation).
    ! Subscribe() with a timeout might have been returning an
      uninitialized  object instead of the notified object.
      Fixed
    * Under pthreads, now threads are started in asynchronous
      cancellation mode to allow simpler termiation scheme. This
      mode is more "powerful" and thus "dangerous" for the
      inexperienced user, but it does mimic the winodws thread
      termination model and it can be controlled with prg level code.
    ! Optimization made threads tests to run more than twice faster
      than before in linux; windws mttest.exe is reporting multithread
      tests to run about the same speed as sequential tests.

  * estack
    ! In an MT environment, if the main thread is requesting his stack
      the main stack is immediately returned, instead of scanning for a
      thread context.
    * Using hb_threadGetContext() to simplify the code and keep all the
      code scanning for a context in just one place.

  * source/rtl/getsys.prg
  * source/rtl/tget.prg
    ! Additional console locking to grant better field input in multithread
      environments. This is still not perfect, but much better.

  * tests/Makefile
    ! harbour compilation rule was missing -I

  * tests/client.prg
  * tests/inetto.prg
  * tests/mtcomplex.prg
    * updated using latest transmission control techniques
    * minimal stylistic fix

2003-01-14 19:07 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/vm/thread.c
    % Minor optimization
    * Formatting

2003-01-15 00:10 UTC-0300 Marcelo Lombardo <lombardo@uol.com.br>
  * source/macro/macro.slx
    ! Fixed macro error if there´s a chr(10) inside a string as this :
      &( " 'line 1' + chr(10) + 'line 2' " )

2003-01-14 03:31 UTC+0100 Giancarlo Niccolai <gian@niccolai.ws>
  * include/inet.h
  * source/vm/inet.c
    + Added a timeout field in the Socket structure.
    ! Now all sockets are internally non blocking, and Select() is used
      to regulate timeout (or infinite wait) accordingly with timeout
      field
    + Added InetSetTimeout and InetClearTimeout function to control the
      timeout field
    + Added the InetRecvEndBlock() by Marcelo Lombardo, a
      generalization of InetRecvLine

  * doc/inet.txt
    * Updated documentation accordingly

  * tests/client.prg
  * tests/inetto.prg
  * tests/server.prg
  * tests/udpclient.prg
    * Updated files to test the new functions and modes
    * Some minor style refinements

  NOTICE: this updates are WIP under windws, and working under linux.
  Tomorrow I will complete them under windows. Sorry for the delay,
  but this is a major design switch.

2003-01-12 23:45 UTC+0100 Giancarlo Niccolai <gian@niccolai.ws>
  * source/vm/Makefile
  * source/rdd/dbfntx/Makefile
  * source/rdd/dbfcdx/Makefile
  * source/rdd/Makefile
  * source/pp/Makefile
  * config/w32/global.cf
  * config/w32/mingw32.cf
  * config/linux/gcc.cf
  * config/linux/global.cf
  * config/darwin/gcc.cf
  * config/darwin/global.cf
  * config/lib.cf
  * make_gnu.sh
  * make_mingw.sh
    * Now HB_MT=MT compilation is actived by default; both the MT libs
      and the non MT libs are compiled. Single makefiles in libraries
      must just declare also MT_LIBFILE=xxxmt to have the make process
      to compile and link the lib in a different ARCH_mt dir with
      -DHB_THREAD_SUPPORT active.
      Please, someone test and check the darwin making.

  * source/vm/thread.c
    + Added the ThreadGetCurrent() function to allow a thread to
      signal it's ID to other threads.

  * source/vm/inet.c
    + Added InetCreate() to pre-create Socket objects
    + InetConnect() and InetConnectIP have now an optional parameter
      (a precreated socket); this allows to kill the connection
      and clear the socket object.

  * doc/inet.txt
    * Docs recflect latest changes

  * tests/inetto.prg
    * Now it has a complete example of asynchronous timeout and connection
      status control.

2003-01-12 23:27 UTC+0100 Francesco Saverio Giudice <info@fsgiudice.com>
  * samples/sitesrv/bldsrv.bat
  * samples/sitesrv/sitesrv.prg
    * Cosmetic changes

2003-01-12 17:50 UTC-0200 Luiz Rafael Culik <culikr@uol.com.br>
  * utils/hbmake/hbmake.prg
    ! An little arrangement on Enabling MT options of the libraries

2003-01-12 17:50 UTC-0200 Luiz Rafael Culik <culikr@uol.com.br>
  * utils/hbmake/hbmake.prg
    ! minor fix when using -R option with Editor mode On Linux
  * source/pp/pptable.c
    + Added missing commands From previus upload( SET FILECASE, SET DIRCASE, SET DIRSEPARATOR)

2003-01-12 10:00 UTC-0200 Luiz Rafael Culik <culikr@uol.com.br>
  * include/hbapifs.h
  * include/hbset.h
  * include/set.ch
  * source/pp/pptable.c
  * source/rtl/file.c
  * source/rtl/filesys.c
  * source/rtl/set.c
    ! Implement SET FILECASE, DIRCASE and DIRSEPARATOR
      This Changes are Borrow from Harbour (author Gustavo Junior Alves <alves@coslinux.com.br>)

2003-01-12 00:26 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/rtl/getsys.prg
    ! Fixed GetActive() to be more Clipper compatible.

  * source/vm/hvm.c
    ! Fixed hb_vmArrayPop() to allow hb_vmArrayPush() optimzation of aTail( NIL ) to return NIL, like Clipper.

2003-01-12 02:30 UTC-0300 Horacio Roldan <harbour_ar@yahoo.com.ar>
  * source/rdd/dbfcdx/dbfcdx1.c
    + ordKeyAdd/Del, now accepts optional value to be used as the key
    ! added cast for MSVC

2003-01-11 10:52 UTC-0300 Horacio Roldan <harbour_ar@yahoo.com.ar>
  * source/pp/pptable.c
    ! fixed while support for rddads
  * include/hbrddcdx.h
  * source/rdd/dbfcdx/dbfcdx2.h
  * source/rdd/dbfcdx/dbfcdx1.c
    ! fixed internal counter that may produce a GPF
    + added support for Unique indexes
    + added support for Custom Indexes
    * work in progress: support for temporary indexes
    + added functions hb_cdxFindBag, hb_cdxEvalKey

2003-01-11 19:00 UTC-0300 Luiz Rafael Culik <culikr@uol.com.br>
  * utils/hbmake/hbmake.prg
    ! Added MT support for hbmake Edit mode

2003-01-11 12:53 UTC+0100 Patrick Mast <patrick@winfakt.com>
  * makefile.bc
    ! Added support for a user defined ARFLAGS
      * if you use -v -y in your CFLAGS, you HAVE to set ARFLAGS to /P64
        to be able to make the MT lib files.

2003-01-11 03:15 UTC+0100 Francesco Saverio Giudice <info@fsgiudice.com>
  * samples/sitesrv/bldsrv.bat
    * fixed error on bld.bat path

2003-01-10 17:58 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * make_b32.bat
    - Removed options [ST|MT|BOTH] now always make BOTH sets of libs.

  * bin/bld.bat
  * makefile.bc
    + Added mt support for rddmt.lib

  /*
     NOTE: Make_b32 and soon all make procedures ALWAYS create both set of libraries ST and MT. The affected lib are:
           vm[mt].lib rtl[mt].lib rdd[mt].lib dbntx[mt].lib dbfcdx[mt].lib

           Bld_b32.bat and similiar applications and samples build batch by default link ST version of libs unless
           HB_MT Environment Variables is set to MT like this: SET HB_MT=mt

  */

2003-01-10 14:51 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * make_b32.bat
    * Changed default make to BOTH

  * bin/bld.bat
  * makefile.bc
    - Removed MT support from rdd.lib
    + Added mt support for dbfcdxmt.lib and dbfntxmt.lib

2003-01-10 23:13 UTC+0100 Giancarlo Niccolai <gian@niccolai.ws>
  + make_mingw.sh
    + Added an easy to use back end for mingw compilation under MSYS shell.
      (should we make this able to start even the MSYS shell by itself?)

  * config/w32/gcc.cf
  * config/w32/global.cf
  * config/w32/mingw32.cf
    ! Added CFLAGS += -DHB_THREAD_SUPPORT if HB_MT is present
    + Added ranlib postlinking of libs (is this correct?)

  * samples/sitesvr/Makefile
  - samples/sitesvr/sitesrv.prg
  + samples/sitesvr/sitesvr.prg
    ! Changed name to sitesvr.prg to match the directory name


2003-01-10 19:14 UTC+0100 Patrick Mast <patrick@winfakt.com>
  * doc/genhtm.bat
    * made it work again

2003-01-10 10:40 UTC+0100 Giancarlo Niccolai <gian@niccolai.ws>
  * samples/sitesvr/sitesrv.prg
    ! Using FOUND() instead of EOF() when scanning for a seek
    * Now that dbfntx is working in recursive searches, I removed
      the SEEK hack and put back the GOTO nRecno / SKIP sequence.
      Thanks, Horacio ;-)

2003-01-09 21:38 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * make_b32.bat
  * makefile.bc
    + Added support for building mt version of vmmt.lib rtlmt.lib and rddmt.lib
      Build syntax is: MAKE_B32 [CLEAN|ST|MT|BOTH] // No paramater default to ST.

  * bin/bld.bat
    + Added support for Env Var: HB_MT - only possible value is MT.
      This will link MT versions of libs building MT capable applications.
      Sample usage:

         MAKE_B32 CLEAN
         MAKE_B32 BOTH
         CD TESTS
         SET HB_MT=MT
         BLD_B32 MTGC
         SET HB_MT=
         BLD_B32 PP

  * include/hbcomp.h
    * Enumeration support - Work in progress

2003-01-10 02:00 UTC-0300 Horacio Roldan <harbour_ar@yahoo.com.ar>
  * source/rdd/dbfntx/dbfntx1.c
    ! fixed positioning bug, reported by Giancarlo Niccolai
  * source/rdd/dbcmd.c
    ! fixed bug with INDEX .. FOR, found and fixed by (Charles) Kwon Oh-Jun

2003-01-08 23:48 UTC+0100 Giancarlo Niccolai <gian@niccolai.ws>
  * source/vm/inet.c
    + Added InetDGRecvTout for time out aware datagram receiving: really
      useful in network scans.
    * Modified InetDataReady so it does accepts an optional timeout
      parameter, useful in stateful TCP connection control

  * doc/inet.txt
    * Updated documentations about added/modified functions in inet.c

  * tests/client.prg
  * tests/udpclient.prg
  * tests/udpserver.prg
    * Modified tests to display useage of latest features


2003-01-08 20:15 UTC+0100 Giancarlo Niccolai <gian@niccolai.ws>
  * source/vm/inet.c
    ! now using htons family function instead of mangling with network
      byte order directly. This should be BIG ENDIAN machine compliant.
    ! Fixed an error in InetDataReady under windows implementation.
    + Added UDP support: InetDGram, InetDGramBind, InetDGRamSend and
      InetDGramRecv.
    + Added interface binding for InetServer
    * InetDataReady working also with DGRAM sockets under LINUX.

  * doc/inet.txt
    + Added documentation for new functions

  + tests/udpclient.prg
  + tests/udpserver.prg
    + Added demos for UDP protocol processing

2003-01-08 10:18 UTC+0100 Giancarlo Niccolai <gian@niccolai.ws>
  * source/vm/inet.c
    ! Fixed compilation under windows

  * tests/inetto.prg
    ! Minor compilation issues

2003-01-08 09:55 UTC+0100 Giancarlo Niccolai <gian@niccolai.ws>
  * source/vm/inet.c
    + Added InetGetHosts, InetGetAlias and InetConnectIP function for better
      control over remote connections.

  + tests/inethosts.prg
    + Test to demonstrate InetGetAlias and InetGetHosts

  + tests/inetto.prg
    + Test to demonstrate asynchronous thread driven timeout control in
      connections, suggested by Charles Kwon


2003-01-07 19:15 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/compiler/harbour.slx
    ! Fixed support for IN when preceded by REJECT_OP ( WANTS_EXP ) - now returns Identifier.

2003-01-07 11:33 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * make_b32.bat
    * Work in progress MT support.
  * include/hbapi.h
  * include/hbstack.h
    * Added missing HB_THREAD_SUPPORT guards.

2003-01-07 16:33 UTC+0100 Giancarlo Niccolai <gian@niccolai.ws>
  * source/rdd/dbfntx/dbfntx1.c
    ! SEGFAULT under linux corrected: latest updates introduced an
      uppercase over the parameters of hb_ntxTagNew. As szKeyExpr
      is a parameter probably allocated in some static memory, under
      linux that parameter is marked as read-only, and modifying it
      (uppercasing it) creates a segfault. Corrected using:

      pTag->nField = hb_rddFieldIndex( (AREAP) pTag->Owner->Owner,
         hb_strUpper(pTag->KeyExpr,strlen(pTag->KeyExpr)) );

      instead of
      pTag->nField = hb_rddFieldIndex( (AREAP) pTag->Owner->Owner,
         hb_strUpper(szKeyExpr,strlen(szKeyExpr)) );


2003-01-07 13:35 UTC+0300 Phil Krylov <phil@mail.ru>
  * config/darwin/gcc.cf
    + Added: CFLAGS += -DHB_BIG_ENDIAN
    + Added: RANLIB = ranlib
  * config/darwin/install.cf
    + Run ranlib on all files installed to HB_LIB_INSTALL
  * include/hbdefs.h
    + Added HB_LOWORD(l) and HB_HIWORD(l) #defines
  * source/compiler/harbour.c
    * (hb_compGenJump, hb_compGenJumpFalse, hb_compGenJumpTrue,
      hb_compGenJumpThere) Use HB_HIWORD for 24-bit jumps - just to improve
      readability
    ! (hb_compGenPushLong) Use HB_LOBYTE, HB_HIBYTE, and HB_HIWORD; this
      fixes (some) big-endian problems
  * source/compiler/harbour.slx
    ! (hb_comp_SLX_InterceptAction) Removed an extra }
  * source/vm/hvm.c
    ! (hb_vmExecute) Use HB_MKLONG on HB_BIG_ENDIAN platforms for HB_P_PUSHLONG
  * source/vm/macro.c
    ! (hb_compGenPushLong) Use HB_LOBYTE, HB_HIBYTE, and HB_HIWORD; this
      fixes (some) big-endian problems

2003-01-06 19:40 UTC-0300 Luiz Rafael Culik <culikr@uol.com.br>
  ! source/rtl/set.c
    ! Fix Problem on hb_setListenerAdd() , the Structure was initializing
     the Next member with Garbage , so, when exiting  the program an GPF
     occur

2003-01-06 18:51 UTC-0300 Marcelo Lombardo <lombardo@uol.com.br>
  * source/rtl/dbsdf.prg
    ! Fixed APPED FROM SDF when CRLF is found before the expected record lenght

2003-01-06 12:36 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/rtl/filesys.c
    ! fixed refernces to DostoWinHandle() NOT protected by #if defined(X__WIN32__)

2003-01-06 13:56 UTC-0300 Horacio Roldan <harbour_ar@yahoo.com.ar>
  * contrib/rdd_ads/ads1.c
  * contrib/rdd_ads/adsfunc.c
  * contrib/rdd_ads/ads.ch
  * contrib/rdd_ads/rddads.h
    ! synched with Harbour

2003-01-06 12:00 UTC-0300 Luiz Rafael Culik <culikr@uol.com.br>
  * include/hbapifs.h
    * When X__WIN32__ is defined FHANDLE is defined as Long
  * source/rtl/filesys.c
    % Properly Fix the usage os Native Windows File IO API. harbour apps with native
      WIN IO api has the same speed as Legacy api usage
  * source/rtl/console.c
    ! Minor Changes required to proper work of Windows File IO Native API

2003-01-06 09:40 UTC-0300 Horacio Roldan <harbour_ar@yahoo.com.ar>
  * include/hbapirdd.h
    ! changed LPDBORDERCONDINFO, borrowed from Harbour.
    ! removed duplicated #defines (used from dbinfo.ch and dbstruct.ch)
  * source/rdd/dbcmd.c
  * source/rdd/dbf1.c
  * source/rdd/workarea.c
    ! several fixes borrowed from Harbour:
      - some strings operations optimized,
      - prevents some buffers overflow, unreleased memory
      - changed LPDBORDERCONDINFO to support WHILE clause for ADS RDD
      - COPY TO ... FIELDS ... is fixed - fields in the result dbf
        are in the same secuence as in the FIELDS clause.
  * include/hbrddntx.h
  * source/rdd/dbfntx/dbfntx1.c
    ! borrowed from Harbour:
      ! some fixes and index optimizations (single field key)
      + support for DBOI_ORDERCOUNT

2003-01-05 20:35 UTC-0300 Horacio Roldan <harbour_ar@yahoo.com.ar>
  * source/rdd/dbfcdx/dbfcdx1.c
    ! fixed numeric scope related bug, reported by Srdjan Dragojlovic
    ! allowing a memo to be used in seeks operations, reported by
      Marek Horodyski

2003-01-05 12:18 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * include/hbapi.h
  * source/vm/fastitem.c
  * source/rtl/str.c
    * Renamed hb_retc[len]Static() to hb_retc[]lenAdoptStatic()

  * source/rtl/chrasc.c
    ! Fixed potential GPF.

2003-01-04 22:47 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * include/hbapi.h
    * Corrected typos related to hb_retcStatic() and hb_reclenStatic()

  * include/hbapiitm.h
  * source/vm/fastitem.c
    + Added hb_itemReturnCopy();
    + Added hb_retclenAdoptRawStatic()

  * source/rtl/chrasc.c
  * source/rtl/left.c
  * source/rtl/memofile.c
  * source/rtl/oemansi.c
  * source/rtl/setkey.c
  * source/rtl/str.c
  * source/rtl/transfrm.c
    * Removed direct access to HB_VM_STACK.

  - source/rtl/do.c
  - source/rtl/errorapi.c
  - source/rtl/inet.c
  + source/vm/do.c
  + source/vm/errorapi.c
  + source/vm/inet.c
  * makefile.bc
  * makefile.vc
  * makefile.nt
  * source/rtl/makefile.bc
  * source/vm/makefile.bc
    -+ Moved HB_VM_STACK (THREAD) dependant modules to VM.

  * source/vm/initsymb.c
    + Added missing Right()

  * source/vm/hvm.c
    - Commented out call to hb_vmSymbolInit() // I belive this to be redandant.

  * include/hbexprb.c
    * Minor corrections to recent fix of macro optimizations of NonLocalVar:AnyMessage
    * Minor correction to optimization of SubStr()
    * Made Left(), Right() and HB_EnumIndex() optimizations avialable at macro compiler too.

  * tests/tstloop.prg
    + Added WHILE .T. test

2003-01-05 02:00 UTC-0300 Marcelo Lombardo <lombardo@uol.com.br>
  * include\hbexprb.c
    ! Changes in hb_compExprUseSend() optimizer to transform anyvar:anymessage
      into memvar->anyvar:anymessage during macro compilation (Cl*pper
      compatibility)

2003-01-04 14:09 UTC+0100 Giancarlo Niccolai <gian@niccolai.ws>
  * samples/sitesvr/Makefile
  * samples/sitesvr/blddbf.prg
  * samples/sitesvr/sitesrv.prg
    ! using lowercase file name convention to allow correct execution in UNIX
    * blddbf is now a separate linked module

  ! source/rtl/inet.c
    ! InetCRLF() was broken :-(. Now it is fixed and correct.

2003-01-04 09:54 UTC+0100 Francesco Saverio Giudice <info@fsgiudice.com>

  Modified SiteSrv example to build dbf on fly to avoid unix/windows conversion
  removed site.dbf, dbt and indexes.

    + samples/sitesrv/blddbf.prg
       + create site.dbf, indexes and add default data
    * samples/sitesrv/sitesrv.prg
       * to call blddbf

2003-01-04 05:28 UTC+0100 Giancarlo Niccolai <gian@niccolai.ws>
  + doc/inet.txt
    + Added basic documentation for Inet api

  + samples/sitesvr
  + samples/sitesvr/Makefile
  + samples/sitesvr/SITE.DBF
  + samples/sitesvr/SITE.VEW
  + samples/sitesvr/SITE.dbt
  + samples/sitesvr/SITE01.NTX
  + samples/sitesvr/SITE02.NTX
  + samples/sitesvr/readme.txt
  + samples/sitesvr/sitesrv.prg
    + Added the site server to the sample directory

  * samples/Makefile
    + Added site server to the samples compilation

2003-01-03 21:07 UTC+0100 Giancarlo Niccolai <gian@niccolai.ws>
  * source/rtl/achoice.prg
    ! Achoiche did not unselect the current item when aborting.
      Fixed

2003-01-02 15:29 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/rtl/traceprg.prg
    * Changed to use variable number of paramaters (...).
    % Optimized to use FOR EACH.

2003-01-02 15:08 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * include/hbtrace.h
  * source/rtl/trace.c
  * source/vm/cmdarg.c
    - Removed param from hb_traceInit()
    + Added logic to auto create trace.log ONLY if application makes use of TraceLog().

2003-01-02 12:11 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * include/hbtrace.h
  * source/rtl/trace.c
    + Added hb_traceInit() and hb_traceExit()

  * source/vm/cmdarg.c
    + Added support for new hb_traceInit()
    + Added support for //NOTRACE application swtitch to disable auto creation of trace.log file.

  * source/vm/hvm.c
    + Added support for new hb_traceExit()

2003-01-02 01:03 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/vm/hvm.c
    ! Fixed HB_P_FUNCTION, HB_P_FUNCTION, HB_P_SEND, and HB_P_SENDSHORT to be Thread Safe.

2003-01-02 07:28 UTC+0100 Giancarlo Niccolai <gian@niccolai.ws>
  * include/inet.h
    ! Using winsock2 instead of winsock. Originarily, it was that way, but
      somehow this has been changed.

2003-01-02 07:01 UTC+0100 Giancarlo Niccolai <gian@niccolai.ws>
  * source/rtl/inet.c
    * removed warning when not compiling with thread support

  * include/inet.h
    ! Fixed compilation ( unresolved SD_BOTH ) on some BCC installations.

2003-01-02 05:44 UTC+0100 Giancarlo Niccolai <gian@niccolai.ws>
  * source/vm/thread.c
    + Now StartThread on method can be called both with a method pointer or
      with a method name:
        StartThread( oMyObject, oMyMethodPtr, ... )
      or
        StartThread( oMyObject, "MethodName", ... )

  * tests/mttest.prg
    * Changed one of the StartThraed to show the "methodname" call.


2003-01-02 04:20 UTC+0100 Giancarlo Niccolai <gian@niccolai.ws>
  * include/hbstack.h
    * Default compilation is now WITHOUT threads; -DHB_THREAD_SUPPORT
      must be specified for thread functions to be included.

  * include/thread.h
  * source/vm/thread.c
    * Changed grammar of StartThread Function as follow (all are
      alternatives)
        StarThread( @Function(), param1 ... paramN )
        StarThread( "Function_Name", param1 ... paramN )
        StarThread( {codeblock}, param1 ... paramN )
        StarThread( Object, Method, param1 ... paramN )
      This allows to pass an object to a function when starting a
      thread as a normal parameter.

  * tests/client.prg
  * tests/mtcomplex.prg
  * tests/mtgc.prg
  * tests/mttest.prg
    * Modified to reflect the change in StartThread grammar.

2003-01-01 21:51 UTC+0100 Giancarlo Niccolai <gian@niccolai.ws>
  * source/vm/garbage.c
    + Added InetCRLF() function in inet module, just a shortcut nice to have.

2003-01-01 19:10 UTC+0100 Giancarlo Niccolai <gian@niccolai.ws>
  * source/vm/garbage.c
    ! Now lock on hb_gcGripGet/Drop are working again.

2002-12-31 16:50 UTC-0300 Luiz Rafael Culik <culikr@uol.com.br>
  * source/vm/thread.c
    ! On Conectiva Linux More then 1 line inside #if/#elif/#endif must be inside {}

2002-12-31 13:10 UTC-0300 Luiz Rafael Culik <culikr@uol.com.br>
  * source/vm/thread.c
    ! Fixed include of time.h and sys/time.h on linux

2002-12-31 13:00 UTC-0300 Luiz Rafael Culik <culikr@uol.com.br>
  * source/vm/fm.c
    ! Fixed Compilation Error on Line 751 and 945(usage of HB_THREAD_SUPPORT with
    out the HB_FM_STATISTICS defined (Reported by Itamar Lins)

2002-12-31 08:05 UTC+0100 Giancarlo Niccolai <gian@niccolai.ws>

  * include/thread.h
    * Default HB_CRITICAL_LOCK for nonwindows systems has become Light
      Weight Reentrant Mutex
    * LWR lockinig Implemented as a macro
      (you should make clean after update)

  * source/rtl/console.c
    * Using HB_CRITICAL_LOCK for locking console, as it is now defined
      to be always reentrant.

  * source/vm/garbage.c
    * Using HB_CRITICAL_LOCK to lock GC, as it is now defined to be always
      reentrant.
    % Under linux, do not lock hb_gcGripGet/hb_gcGripDrop. This is a temporary
      hack:is working but we must find out why this lock causes deadlocks
      AND possibly sigsev, while removing it deadlock is gone and seg faults
      are far less. Under windows this to be working, so I left that alone.

  * source/vm/thread.c
    ! Now mutex at PRG level are working again: CreateMutex() LockMutex() etc
      are working again now.
    + Now StopThread() can be given an optional second parameter that is a
      mutex on which the target thread might be subscribing, so to release
      it more cleanly. Just a finesse, but is nice to have it.

  * tests/mtcomplex.prg
    * The second StopThread() has been updated to use the new grammar.

2002-12-30 16:56 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/vm/arrayshb.c
    ! Fixed Array() to be Thread Safe.

  * source/vm/hvm.c
  * source/vm/arrays.c
  * source/vm/codebloc.c
  * source/vm/thread.c
  * source/vm/garbage.c
    ! Many fixes to be Thread Safe.

2002-12-30 16:50 UTC-0300 Horacio Roldan <harbour_ar@yahoo.com.ar>
   * source/rdd/dbfcdx/dbfcdx1.c
        ! fixed scope related bug, reported by Blue Face
        + added support for the EVAL clause in INDEX

2002-12-29 21:03 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/vm/hvm.c
  * source/vm/arrays.c
  * source/vm/codebloc.c
    * Reverted to PRE Forbid version.
    * Changed HB_CRITICAL_[UN]LOCK() to hb_threadForbid/Allow()

  * include/thread.h
  * source/vm/thread.c
    - Removed [Un]Lock support from HB_FORBID_MUTEX related logic.

  * source/vm/garbage.c
    ! Fixed to correctly support new Forbid/Allow scheme.

2002-12-29 16:12 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/vm/arrays.c
  * source/vm/garbage.c
  * source/vm/thread.c
    * Minor improvements and fixes.

2002-12-30 00:26 UTC+0100 Giancarlo Niccolai <giancarlo@niccolai.ws>
  * source/vm/thread.c
  * include/thread.h
    + Added hb_threadForbid* function family to manage Forbid Mutex type.

  * source/vm/arrays.c
  * source/vm/codebloc.c
  * source/vm/fm.c
  * source/vm/garbage.c
  * source/vm/hvm.c
    * Added Forbid Mutex Method to allow concurrent updating of Garbage Collecting.

2002-12-29 11:54 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  *  source/vm/arrays.c
  *  source/vm/codebloc.c
  *  source/vm/hvm.c
    ! More thread safety fixes.

2002-12-29 09:53 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/vm/garbage.c
  * source/vm/hvm.c
  * source/vm/thread.c
    ! Minor fixes to GC Thread Safety.

2002-12-29 00:28 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * include/thread.h
  * include/hbapi.h
  * source/vm/thread.c
    + Added hb_threadIsLocalRef( void )

  * include/hbstack.h
    + Added #define STACK_THREADHB_ITEMS 100

  * source/rtl/console.c
  * source/rtl/errorapi.c
  * source/rtl/idle.c
  * source/rtl/inet.c
  * source/vm/arrays.c
  * source/vm/estack.c
  * source/vm/fm.c
  * source/vm/hvm.c
  * source/vm/itemapi.c
    * Corrected naming convention for new thread functions.

  * source/vm/garbage.c
    * Added optional logical paramater lForceCollection to HB_GCALL() to force collection even if GC statistcs do not justify collection.
    ! GC is now Thread Safe and much optimized. xHarbour applications should be significantly faster.

2002-12-28 09:05 UTC-0300 Horacio Roldan <harbour_ar@yahoo.com.ar>
   * source/rdd/dbfcdx/dbfcdx1.c
   * source/rdd/dbfcdx/dbfcdx2.h
        ! fixed bug (search path related),
          reported by Jacek Potempa <Jacek.Potempa@otc.pl>
        ! fixed GPF bug reported by Alex Schaft <alexs@quicksoftware.co.za>
        + added support for DBOI_KEYCOUNTRAW, DBOI_KEYNORAW == DBOI_RECNO,
          DBOI_KEYTYPE, DBOI_KEYSIZE, DBOI_FULLPATH
        ! fixed: DBOI_BAGNAME
        ! fix return value when there's no active order to: DBOI_FILEHANDLE,
          DBOI_ISCOND, DBOI_ISDESC, DBOI_UNIQUE, DBOI_POSITION, DBOI_RECNO,
          DBOI_KEYNORAW, DBOI_KEYCOUNT, DBOI_KEYCOUNTRAW.
          This makes ordKeyNo() = recno() and ordKeyCount() = lastrec()
          in such case. Reported by Hernán Diego Ceccarelli
          <hceccarelli@cesotech.com.ar>
        + added helper function hb_cdxOrdListClear
        ! structural index isn't closed anymore
        ! fixed ordKeyNo() and ordKeyCount() to respect filters, they also
          respect the set deleted but only when there is a filter (as C53)
        ! fixed ordScope(0/1, ""), reported by Jean-Christophe AVARGUES and
          Blue Face

   * source/rdd/workarea.c
        ! fix to fieldname, reported by Luiz Rafael Culik

   * include/ord.ch
   * include/dbstruct.ch
        ! minor changes
   * source/rdd/dbcmd.c
        ! fixed GPF, reported by Patrick Mast

2002-12-27 21:41 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * include/hbapi.h
    * Excluded estack.h from being included when building compiler.
      This fixes many compiles error related to premature inclusion of windows.h on Windows platforms.

  * source/rtl/console.c
  * source/vm/fm.c
  * source/vm/garbage.c
    * Added guard to NOT call hb_LWRM_[un]lock() unless MT is indded utilized.
      This fixes GPF related to th eabove functions in NON MT applications.

2002-12-27 23:28 UTC+0100    Giancarlo Niccolai <giancarlo@niccolai.ws>
  * include/hbstack.h
  * include/inet.h
  * source/rtl/inet.c
  * source/vm/estack.c
  * source/vm/thread.c
    ! compilation problems with -DHB_NO_DEFAULT_THREADS are now fixed

  * source/rtl/inet.c
    * Removed completely (using comments) locking mechanism upon sockets. To be studied
      more deeply when MT/GC is working.

2002-12-26 03:38 UTC+0100  Giancarlo Niccolai <giancarlo@niccolai.ws>
  * include/thread.h
    source/vm/thread.c
    + Added multiplatform lightweight reentrant mutex to be used internally by x-harbour
    + hb_LWRM_lock( HB_LWR_MUTEX *lpMutex ) / hb_LWRM_unlock( HB_LWR_MUTEX *lpMutex )

  * source/rtl/console.c
    * Changed the internal mutex to a lightweight reentrant mutex

  * source/rtl/idle.c
     % Added a "marker" around the point that generates an error in MT. Will have to work it
     out in the next days

  * source/rtl/inet.c
    * Commented out mutex sections; will have to decide if keep them (and turn them into LWRM or
      remove them) in the next few days

  * source/vm/fm.c
    source/vm/garbage.c
    ! Added mutex around concurrent allocation/deallocation of shared memory.

2002-25-12 12:20 UTC-0300 Walter Negro <anegro@overnet.com.ar>
  * source/rtl/tbrowse.prg
    ! Fix, PanLeft() and PanRight() methods.
    ! Add funcionality to ColorRect() method.
    Reported by Luiz Culik

2002-12-23 22:41 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * include/hbtrace.h
  * source/rtl/trace.c
    Added:
      extern void TraceLogValue( const char * sFile, const char * sTraceMsg, long Value );
      extern void TraceLogPointer( const char * sFile, const char * sTraceMsg, void *Pointer  );

  * include/inet.h
  * source/rtl/inet.c
    + Added HB_INET_CARGO structure
    + Added HB_CRITICAL_INET* Mutex macros.
    + Added auto critical sections protection to all critical sections.
    * Modified InetRecvLine() to:
      InetRecvLine( Socket [,@nResult [, nMax, [, nBufferSize] ] ] ) => cLine

  * source/vm/thread.c
    + Added Stack cleanup in hb_destroyContext().

  * source/rtl/console.c
    * Corrected declaration of hb_consolLock() and hb_consoleUnlock().

  * tests/client.prg
  * tests/server.prg
    * Corrected InetRecvLine() usage.

  * include/ord.ch
    - Removed #define of entries recently added under dbinfo.ch

2002-12-23 22:40 UTC-0300 Luiz Rafael Culik <culikr@uol.com.br>
  + include/ttable.ch
    + Commands for Table/Record and Field classes
  + source/rtl/ttable.prg
    + Source code for Table,Record and Field Classes
  * include/Makefile
   + Added ttable.ch to PRG_HEADERS
  *  source/rtl/Makefile
     makefile.bc
     makefile.vc
   * Added ttable.prg to dependencie list
  + tests/TstTable.prg
    * Test For table Class

2002-12-23 18:00 UTC-0300 Luiz Rafael Culik <culikr@uol.com.br>
  + include/dbinfo.ch
    + Added missing dbinfo.ch From harbour
  + include/Makefile
    + Added dbinfo.ch to PRG_HEADERS
  * utils/hbmake/hbmutils.prg
    * Added ability to get Directories with extension

2002-12-23 07:38 UTC+0100  Giancarlo Niccolai <giancarlo@niccolai.ws>
  * include/hbapigt.h
  * source/rtl/console.c
    * Chanced the Critical Section for console output into a reentrant
      mutex (manually handed)
    + Added hb_consoleLock() and hb_consoleUnlock() to allow other api part to
      lock the screen
    + Added HB_FUNC HBConsoleLock() and HBConsoleUnlock() to allow PRG to have
      mutex on screen.

  * source/rtl/alert.prg
    ! Fixed MT alert unreadability: adding HBConsoleLock() to Alert, no other
      thread can write
      to screen in the meanwhile

  * tests/client.prg
    ! Check on InetErrorCode has been fixed

2002-12-23 03:30 UTC+0100 Giancarlo Niccolai <giancarlo@niccolai.ws>
  *include/hbapi.h
    ! A section was declared twice. Removed the unused copy (that would block
      compilation).

  * source/rtl/inet.c
    * Repristinated both windows availability for InetDataReady and new grammar
      for InetReadLine

  * tests/client.prg
    * Changed to match new InetReadLine grammar

  * tests/server.prg
    * Changed to match new InetReadLine grammar

2002-12-22 22:49 UTC+0100 Giancarlo Niccolai <giancarlo@niccolai.ws>
  * source/rtl/inet.c
    + added check for ISBYREF(2) in all the InetRecv*()
    * InetReadLine now has format (Sock, @C, [N]) and C can be allcated
       on the fly
    ! InetDataReady is now available under Windows ( using select() )

  * client.prg
    * updated to match Inet api change

  * server.prg
    * updated to match Inet api change

2002-12-22 16:12 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * include/thread.h
  * source/vm/thread.c
    + Added support for Destructor and Cargo.
      If Destructor is defined it's calls from hb_DestrotContext*().

  * include/inet.h
  * source/rtl/inet.c
    * Rewriten.
    + Added support for Thread Destructor on blocking function calls.

  * source/vm/estack.c
    * hb_getCurrentStack() always included.

  * source/vm/hvm.c
    * #include Refinments.

  * include/hbapi.h
    + Added hb_retclenAdoptRaw()
    * #include Refinments.

  * source/vm/extend.c
    ! Fixed support for hb_param( n, HB_IT_BYREF )

  * source/vm/fastitem.c
    + Added hb_retclenAdoptRaw()

  * source/rtl/set.c
    ! Fixed compiler warnings.

  * source/pp/ppcore.c
    * Fix in progress.

  * tests/client.prg
  * tests/server.prg
    * Made compabtible with revised inet module.

2002-12-22 03:54 UTC-0300 Walter Negro <anegro@overnet.com.ar>
  * include/hbstack.h
    ! DOS is not compatible with multithreads, use hb?stack.
  * include/inet.h
    ! DOS is not compatible with TCP&IP native.
  * source/rtl/inet.c
    ! DOS is not compatible with TCP&IP native.
  * source/rtl/set.c
    ! In the set_string function, when then item parameter is NIL use a
      zero-length string (bug fix for SET PATH TO and SET DEFAULT TO).
      Borrowed from Harbour, change made by David G. Holm
    ! Fix, reset PRINTFILE handle when close file.

2002-12-22 22:49 UTC+0100 Giancarlo Niccolai <giancarlo@niccolai.ws>
  * source/rtl/inet.c
    + added check for ISBYREF(2) in all the InetRecv*()
    * InetReadLine now has format (Sock, @C, [N]) and C can be allcated on the fly
    ! InetDataReady is now available under Windows ( using select() )

  * tests/client.prg
    * updated to match Inet api change

  * tests/server.prg
    * updated to match Inet api change

2002-12-22 01:29 UTC+0300 Phil Krylov <phil@mail.ru>
  * include/inet.h
    + #include <netinet/in.h> on Darwin for "struct sockaddr_in" definition
  * source/vm/thread.c
    + #include <stdlib.h> instead of <malloc.h> on Darwin
    + #include <unistd.h> on Darwin for usleep()
    + Use usleep() instead of nanosleep() on Darwin

2002-12-21 10:19 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/rtl/errorsys.prg
    * Corrected Display of ProcName and ProcLine.

  * source/vm/thread.c
    * Improved hb_threadExit() to kill all running threads.

  + tests/client.prg
  + tests/server.prg
    + New inet samples.

2002-12-20 20:15 UTC-0300 Luiz Rafael Culik <culikr@uol.com.br>
  * include/thread.h
    * Fixed Problem on Some Macros on Linux Section of File(was missing the &
    operator on some Macros)

2002-12-20 11:50 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
   + tests/mtcomplex.prg
     + Added demo with some more advanced MT features.

2002-12-20 11:50 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
   * include/inet.h
   * source/rtl/inet.c
     * Minor fixes for MSVC.

   * makefile.vc
   * makefile.nt
     + Added inet.c

2002-12-20 11:39 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
   * include/inet.h
     + Added missing defines.
   * makefile.bc
     + Added inet.c

2002-12-20 10:00 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * include/thread.h
    + Added guarded explict #define for _WIN32_WINNT 0x0400

  * source/vm/thread.c
    * Minor corrections related to HB_CRITICAL_LOCK()

  * bin/bld.bat
    * Added shell32.lib libs to MSVC section.

2002-12-20 01:16 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * include/thread.h
    - Temporarily commented out SignalObjectAndWait() because it's not avialable on all Win32s.
  * source/rtl/console.c
    * Modified all HB_MUTEX*() to HB_CRITICAL*()

2002-12-20 00:36 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * include/thread.h
  * source/vm/estack.c
  * source/vm/hvm.c
  * source/vm/thread.c
    * Restored Windows support.

2002-12-19 10:13 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * include/hbapi.h
  * include/hbstack.h
  * include/thread.h
  * source/rdd/dbcmd.c
  * source/rdd/dbfcdx/dbfcdx1.c
  * source/rdd/dbfntx/dbfntx1.c
  * source/rtl/chrasc.c
  * source/rtl/do.c
  * source/rtl/errorapi.c
  * source/rtl/left.c
  * source/rtl/memofile.c
  * source/rtl/oemansi.c
  * source/rtl/setkey.c
  * source/rtl/str.c
  * source/rtl/transfrm.c
  * source/vm/arrays.c
  * source/vm/arrayshb.c
  * source/vm/asort.c
  * source/vm/classes.c
  * source/vm/codebloc.c
  * source/vm/debug.c
  * source/vm/estack.c
  * source/vm/eval.c
  * source/vm/extend.c
  * source/vm/fastitem.c
  * source/vm/fm.c
  * source/vm/garbage.c
  * source/vm/hvm.c
  * source/vm/itemapi.c
  * source/vm/memvars.c
  * source/vm/proc.c
  * source/vm/pvalue.c
  * source/vm/runner.c
  * source/vm/thread.c
    + Added new macro HB_VM_STACK
    * Cleaned all references to hb_stack to use new macro HB_VM_STACK

 /*
    xHarbour with MT support is again compatible with all 3rd party LIBs.
    There is NO LONGER any need to use -DHB_NO_DEFAULT_THREADS other then
    for research purposes.
  */

2002-12-18 08:43 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * makefile.nt
  * makefile.vc
  * source/vm/Makefile
    + Added thread.c

  * source/vm/thread.c
    + Added few missing type casts.

  * source/rtl/win32ole.prg
    * Reordered #defines and #includes.

  * source/pp/pragma.c
    ! Fixed really slippery gpf.

2002-12-18 05:40 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  + include/thread.h
  + source/vm/thread.c
    + New MT support originated by Giancarlo Niccolai [gian@niccolai.ws]
      Revisions and additions by Ron Pinkas

  * include/hbcomp.h
    - Removed unneeded #include.

  * include/hbstack.h
    + Added support for new MT

  * source/vm/estack.c
    + Added #ifdef guarded hb_getCurrentStack() as an alternative to dirrect access to hb_stack.

  * source/vm/hvm.c
    + Added: #ifdef guarded hb_contextInit() to hb_vmInit()
    + Added: #ifdef guarded Sleep Loop to to hb_vmQuit()

  * source/pp/pptable.c
    * Changed definitions of @ x,y SAY ... to pass Row & Col as additional paramaters to DevOut*()
      /* This is required so that more efficent Mutex can be set for the combined operation. */

  * source/rtl/console.c
    + Added MT Mutex support to all PRG level Output Functions.
    * Added 2 optional paramaters nRow, nCol to DevOut().

  * source/rtl/devoutp.prg
    * Added 2 optional paramaters nRow, nCol to DevOutPict().

  * source/rtl/tprint.c
  * source/rtl/tprinter.c
    * Minor corrections.

  * makefile.bc
    + Added support for thread.c

  + tests/mttest.prg
    + New test file to demonstrate new MT capability.

  * source/vm/arrays.c
    * Corrected comment.

  * source/rtl/errorsys.prg
    + Added TraceLog() just before Alert()

  * source/rtl/regex.c
    * Work in progress.

2002-12-17 12:40 UTC-0300 Walter Negro <anegro@overnet.com.ar>
  * source/tget.prg
    ! Fix, UpdateBuffer() should not actualize the variable if the value
      was not modified.

    Reported by Francisco Gamboa and Horacio Roldan

2002-12-16 20:20 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * include/hbapi.h
  * source/vm/classes.c
    * Added 4th optional paramater BOOL *bConstructor to hb_objGetMthd().

  * source/vm/hvm.c
    ! Fixed hb_vmSend() to always return Self if method is a Constructor.

    /*
       This was NOT Clipper OOP engines compatible, as I recently found to my surprise that
       RETURN NIL was ending some METHOD New(...) and it was working perfectly in Clipper [Objects].
       Same code was naturally breaking in xHarbour. Now I don't consider RETURN of anything other
       than Self as good practice, but for compatibility, I thought this should be fixed.
     */

2002-12-16 08:31 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
   * include/hbapi.h
     * Added () around macro paramaters expansion.

2002-12-15 22:00 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * config/rules.cf
    ! Removed extra endif

  * config/w32/mingw32.cf
    + Added: LINKLIBS += -luser32 -lwinspool -lole32 -loleaut32 -luuid

  - include/tprint.hpp
  - source/rtl/tprinter.cpp
  - source/rtl/tprint.cpp
  + source/rtl/tprint.c
  + source/rtl/tprinter.c
    -+ Replaced C++ implementation with C.

  /* Luiz: I wish I understood WHY you coded that in C++??? */

  * source/rtl/Makefile
    - Removed tprint.cpp and tprinter.cpp
    - Added tprint.c and tprinter.c

  * source/rtl/console.c
  * source/rtl/set.c
    * Commented && (!defined(__MINGW32__))

  * source/vm/arrays.c
    - Removed unused var.

2002-12-15 21:40 UTC-0300 Luiz Rafael Culik Guimaraes <culikr@uol.com.br>
  * config/c.cf
    config/rules.cf
    * Added rules to compile .cpp files
  * source/rtl/Makefile
    + Added tprint.cpp
  * utils/hbmake/hbmake.prg
    * Minor change

2002-12-15 15:00 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * config/w32/global.cf
    * Minor corrections.

  * include/regex.h
    - Commented out definitions for BOOL, TRUE, FALSE

  * source/rtl/Makefile
    + Added win32ole.prg

  * bin/bld.bat
    * Added missing libs to MINGW32 section.

  * source/pp/ppcore.c
    + Added hb_ppPlatform() based on code from hb_verPlatform()
    + Added support for auto-defined __PLATFORM__... ... where ... is first word from hb_ppPlatform() // Need to correct OS/2 and check L*x.

  * source/rtl/set.c
  * source/rtl/console.c
  * source/rtl/tprint.cpp
    + added && (!defined(__MINGW32__)) guards arounf Windows specific function calls that are not yet setup for MingW32.

    /* Anyone knows how to add tprint.cpp to source/rtl/Makefile so we can fix this FIX this!!! */

  * source/rtl/filesys.c
    ! Corrected _LK_UNLOCK to _LK_UNLCK within __MINGW32__ guard.

  * source/rtl/regex.c
    Moved #include "hbapi.h" to top.

  * source/rtl/win32ole.prg
    + Added #ifndef __PLTAFORM_Windows guard so we may have CreateObject() and GetActiveObject() return NIL on NON Windows platforms.

  * source/vm/itemapi.c
    ! Fixed GPF in MingW32 build for Str(Log(-1))

    /* Can someone more familiar with match exceptions review this
       - Log(-1) returns 1.IND#00, this was the quickest way for me to fix this. */

    /* Under MingW we have 111 failing tests - this is related to Log(-1) Sqr(-1) upper() and lower()
       can anybody review this... (Paul?) */

2002-12-13 12:05 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/compiler/harbour.slx
    * Moved .F., .N., .T., .Y. to list of SELF_CONTAINED_WORDS.

2002-12-13 02:22 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * include/regex.h
  * source/rtl/regex.c
    -+ Replaced RegEx engine to PCRE. Written by: Philip Hazel <ph10@cam.ac.uk> Copyright (c) 1997-2001 University of Cambridge.
      This engine is FAR more powerful, and FAR faster.

  * doc/regex.txt
    -+ Replaced with text from pcre.tx which is the complete documentation of PCRE originaly pcre.txt
       /* NOTE: This does include general Regular Expressions documentation, for those intrested. */

  * tests/tstregex.prg
    * Minor modifications to show \b (begin of word), feature not avialable before.

2002-12-12 20:11 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/rtl/regex.c
    ! Minor corrections.

  * tests/tstregex.prg
    * Better example and comments.

  * tests/pp.prg
    * Few optimizations, and 1 usage of RegEx within and #ifdef __XHARBOUR__

2002-12-11 10:56 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * makefile.nt
  * makefile.vc
    * Minor corrections.
  * source/rtl/regex.c
    * Minor modification to allow compilation under MSVC.

2002-12-11 03:04 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  + include/regex.h
  + source/rtl/regex.c
    + Added RegEx engine based on RegEx 4.4-2 Copyright 1992, 1993, 1994, 1997 Henry Spencer.
    + New RegEx Search function HB_AtX( <sRegEx>, <sTring>, <lCaseSensitive>, [[@]nStart], [[@]nEnd] ) => <sFoundText>
      /* if nStart and/or nEnd are passed BY REFERENCE, they will be set to Start and Length of found text. */

  + doc/regex.txt
    + Copyright notice as per COPYRIGHT terms.

  + tests/tstregex.prg
    + Small demo test of new HB_AtX( <sRegEx>, <sTring>, <lCaseSensitive>, [[@]nStart], [[@]nEnd] )

  * makefile.bc
  * makefile.vc
  * source/rtl/Makefile
    * Added rtl/regex.c

2002-12-08 12:02 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/compiler/harbour.slx
  * source/compiler/harbour.sly
    + Added support for new syntax:
      TRY
         ...
         [THROW( <exp> )]
         ...
      [CATCH <Id>]
      END

  * source/rtl/terror.prg
    + Added HB_SetTry() and HB_ResetTry()
    + Added Optional Paramaters ( SubSystem, SubCode, Operation, Description, Args ) to contructor ErrorNew()

  * source/vm/break.c
    + Added new Throw( xExp )

  + tests/trycatch.prg
    + New sample to demonstrate new TRY [THROW...] [CATCH ...] END syntax.

2002-12-07 18:16 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/macro/macro.slx
    * Removed recent addition of of reset yylval.string to NIL on EOF token.

  * source/macro/macro.y
    ! Fixed gpf related to hb_xfree() of yylval.string

2002-11-07 21:45 UTC-0300 Luiz Rafael Culik <culikr@uol.com.br>
  * source/rtl/menuto.prg
    ! Fixed Color Parameters when only One color is passed

2002-12-06 18:53 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * include/hbexprb.c
  * source/macro/macrob.c
  * source/compiler/exproptb.c
    * Excluded compile time optimization of strings '=' comparison because it's R/T dependant on SET EXCACT.

2002-12-06 09:34 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/compiler/exproptb.c
  * source/macro/macrob.c
    * Touched to force compilation of expropt2.c

  * include/hbexprb.c
    - Removed code duplicated in expropt2.c (hb_compReduceEQ())

  * source/common/expropt2.c
    + Added #ifdef HB_OPTIMIZE_LOGICAL_COMPARISON guard to optimizations of:
         Exp == .T. -> Exp
         Exp == .F. -> ! Exp
         .T. == Exp -> Exp
         .F. == Exp -> ! Exp
     because of compatibility side effect: IF NIL == .T. -> IF NIL // R/T Error.

2002-12-06 00:01 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/macro/macro.slx
    ! Fixed gpf related to yylval.string not being reset to NIL

2002-12-06 01:00 UTC-0300 Walter Negro <anegro@overnet.com.ar>
  * source/rtl/tbrowse.prg
    ! Missing Local variable declaration

2002-12-05 17:50 UTC-0300 Walter Negro <anegro@overnet.com.ar>
  * source/rtl/tbrowse.prg
    * now tbrowse support:

    * support nTop,nLeft,nRigth,nBottom increase/decrease dynamically
      with automatic adjustment of the width of the columns.

    + add support for Border with dynamic change.
    * add support for change dynamic in ColorSpec.

    * Automatic adjust of header/footer if there is not place to show one
      line at least.

    + Generate TBROWSE error for incorrect coordinates.

    * Complete support for dynamic add, del, insert and change (set)
      column with automatic adjustment of the width of the columns.

    * Complete support for dynamic change of freeze columns.

    * Change in code for increase of speed, written mostly by Pritpal Bedi

  all these changes were made, tested, criticized and mutually corrected
  by Pritpal Bedi and Walter Negro.

2002-12-04 17:17 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/rtl/binnum.c
    * Corrected recent optimization of Bin2L() to support strings shorter than 4 bytes long.

2002-12-05 01:23 UTC+0300 Phil Krylov <phil@mail.ru>
  + make_drw.sh
     + Added a GNU-make starter for Darwin
  + config/darwin/dir.cf
  + config/darwin/gcc.cf
  + config/darwin/global.cf
  + config/darwin/install.cf
    + New GNU Make System modules for Darwin
  * doc/gmake.txt
    + Added documentation for darwin/gcc
  * source/compiler/harbour.c
  * source/compiler/harbour.sly
  * source/vm/fm.c
  * source/vm/hvm.c
  * utils/hbpp/hbpp.c
    + #include <stdlib.h> instead of <malloc.h> on Darwin
  * source/rtl/idle.c
    + Added 'usleep(1);' to hb_releaseCPU() for Darwin
    + Added '#include <unistd.h>' on Darwin

2002-12-03 22:22 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * include/hbcomp.h
  * include/hbmacro.h
  * source/compiler/harbour.c
  * source/vm/macro.c
    + Added void hb_compGenPushMemVarRef( char * szVarName );

  * include/hbexpra.c
  * include/hbexprb.c
  * include/hbexprop.h
  * source/common/expropt1.c
    + Added support for new HB_ET_MEMVARREF.

  * source/compiler/harbour.sly
    + Added support for @M|MEMV[AR]->SomeVar as function argument.

2002-12-01 0:55 UTC-0300 Walter Negro <anegro@overnet.com.ar>
  * source/debug/dbgtarr.prg
  * source/debug/dbgtmenu.prg
  * source/debug/dbgtobj.prg
  * source/debug/dbgwa.prg
  * source/debug/debugger.prg
  * source/debug/tbrwtext.prg
    ! Several optimizations. Adel, Ains, FOR EACH, or/and IN.

2002-11-29 17:00 UTC-0300 Walter Negro <anegro@overnet.com.ar>
  * source/rtl/achoice.prg
  * source/rtl/alert.prg
  * source/rtl/cstr.prg
  * source/rtl/devoutp.prg
  * source/rtl/errorsys.prg
  * source/rtl/listbox.prg
  * source/rtl/memoedit.prg
  * source/rtl/objfunc.prg
  * source/rtl/persist.prg
  * source/rtl/pushbtn.prg
  * source/rtl/tclass.prg
  * source/rtl/tget.prg
  * source/rtl/tlabel.prg
  * source/rtl/treport.prg
    ! add recent optimization. <exp> IN <string_or_array>
  * source/rtl/cstruct.prg
    * delete redundant code.
  * source/rtl/tbcolumn.prg
    ! Set ::DefColor to four numeric values.
      The third color display the heading.
      The fourth color display the footing.

2002-11-29 00:56 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/rtl/binnum.c
    ! Minor optimization.
  * source/rdd/dbcmd.c
    ! Fixed __dbLocate NOT respecting WHILE clause.
    * Formatting.

2002-11-27 02:00 UTC-0300 Marcelo Lombardo <lombardo@uol.com.br>
  * source\rdd\workarea.c
    ! Fixed hb_waRelEval() - When the current order is zero, relation works
      by GOTO istead of SEEK, as Cl*pper does

2002-11-24 21:07 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/compiler/simplex.c
  * source/compiler/hbslex.c
  * source/compiler/harbour.slx
    ! Speed optimizations.

  * source/compiler/harbour.slx
    + Added support for IN as an Operator. Syntax is: <exp> IN <ArrayOrStringExp> => .T./.F.

  * source/vm/hvm.c
    + Added array support for HB_P_INSTRING.
    * Renamed hb_vmInString() to hb_vmInStringOrArray()

  + tests/testin.prg
    + New test for IN operator.

  /*
     NOTE: IN operator is about 25% faster than aScan(...) > 0
  */

2002-11-24 09:49 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * include/hbcomp.h
  * source/compiler/harbour.c
  * source/compiler/harbour.slx
  * source/compiler/harbour.sly
    * Changed all SET to refrences to ENUM.

  /*
    Corrected syntax is:

    ENUM[ERATION] <SetName> := <Member1> [, <MembersN>] ...

    LOCAL/STATIC <VarName> AS ENUM[ERATION] <SetName>

    <VarName> := <MemberX>

    This is still work in progress.
  */

2002-11-23 21:27 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * include/hbcomp.h
  * source/compiler/harbour.c
  * source/compiler/harbour.slx
  * source/compiler/harbour.sly
    + Added foundation for true Sets, compile time support.

  /*
    Syntax is:

    SET <SetName> := <Member1> [, <MembersN>] ...

    LOCAL/STATIC <VarName> AS SET <SetName>

    <VarName> := <MemberX>

    This is a work in progress. The above will parse correctly,
    but no compile time error will be produced for invalid assignments yet.
  */

2002-11-20 21:45 UTC-0300 Luiz Rafael Culik <culikr@uol.com.br>
  * source/pp/pptable.c
    + COLOR parameter to @...PROMPT
  * source/rtl/menuto.prg
    ! Added code to use the passed Color to the Prompt.This will allow
    to make Color menus and Was Far Requested since this feature is an Alaska,Flagship and Max compiler
  * tests/menuto.prg
    * Changes the Test to Show the ability of menu items in colors

2002-11-19 23:40 UTC-0300 Luiz Rafael Culik <culikr@uol.com.br>
  * source/rtl/gtsln/kbsln.c
    ! Added Define to enable Only ONE ESC KEY press. To use the sources must be compiled with HB_SLANG_ONE_ESC

2002-11-19 11:30 UTC+0530 Pritpal Bedi <pritpal@vouchcac.com>
  * source/rtl\tbrowse.prg
    ! Heavily optimized code to match the speed of Clipper. A few
      Properies are deleted and some new are created. Code for
      :forceStable() method is contributed by Sandeep ( Thanks ).
      Though a few issues are still left to match the Clipper
      behaviour, but hope soon I will get a solution for them as well.

2002-11-18 15:45 UTC+0100 Marek Paliwoda <paliwoda@inetia.pl>
  * source/vm/arrays.c
    ! Fixed problems causing random GPFs - mainly under Win/Bcc

2002-11-17 16:36 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/macro/macro.y
    ! Fixed 2 possible memory leaks.

2002-11-15 12:15 UTC-0300 Walter Negro <anegro@overnet.com.ar>
  * bin/bld.bat
    + Add the math library to compilation.

2002-11-14 13:43 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/vm/arrays.c
  * source/vm/hvm.c
    ! Optimized recent fix to HB_P_ARRAYPUSH of element BYREF.

2002-11-14 12:30 UTC-0300 Walter Negro <anegro@overnet.com.ar>
  * config/dos/djgpp.cf
    + Add the math library to compilation.

2002-11-14 00:03 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/vm/hvm.c
    ! Fixed HB_P_ARRAYPUSH when Element is BYREF (unref).

2002-11-13 17:37 UTC-0300 Walter Negro <anegro@overnet.com.ar>
  * source/rtl/listbox.prg
  * source/rtl/radiogrp.prg
  * source/rtl/teditor.prg
  * source/rtl/tpopup.prg
    * Optimization of code, using AIns() and ADel() extended.
  * source/rtl/ttopbar.prg
    * Optimization of code, using FOR EACH - HB_EnumIndex() and
      AIns() and ADel() extended.

2002-11-13 15:50 UTC-0300 Horacio Roldan <harbour_ar@yahoo.com.ar>
   * include/hbrddcdx.h
   * source/rdd/dbfcdx/dbfcdx1.c
   * source/rdd/dbfcdx/dbfcdx1.h
   * source/rdd/dbfcdx/dbfcdx2.h
        ! fixed some declarations to avoid warnings,
          removed unnecessary introduced casts
        ! fixed skip bug reported by Andrzej
        ! fixed bug when empty scope used
        ! fixed posible index corruption when shared.
        + added functions cdxError, hb_cdxOrderListRebuild,
          hb_cdxIndexReindex
          Now reindex works, as well as pack and zap.

   * source/rdd/dbfntx/dbfntx1.c
        ! fixed skip bug, key updating
        ! Bug fixed ( setting controlling index doesn't caused movement to the
          top logical record before )
          Fixes from Harbour by Alexander Kresin

2002-11-13 12:35 UTC-0300 Walter Negro <anegro@overnet.com.ar>
  * source/rtl/gtdos/gtdos.c
    + Add support for DispBegin() and DispEnd() for DJGPP.

2002-11-13 12:03 UTC-0300 Walter Negro <anegro@overnet.com.ar>
  * include/hbfixdj.h
    + Fix for DJGPP compiler. ( isupper, islower, is..., toupper, tolower )
  * include/hbsetup.h
    + Add include for fix problems in DJGPP.

2002-11-13 11:44 UTC-0300 Walter Negro <anegro@overnet.com.ar>
  * source/rtl/tbrowse.prg
    * More compatibility when freezing columns.
      Report by Luiz Culik.
    * The cell contains the width of the data. Same of Cl*pper.
    * Optimizations of speed making previous calculations.
    * Optimizations made by Pritpal Bedi. (::nRowData, ::aColsPict)
    * Optimizacions of speed using commands and functions specifics of
      xHarbour. (FOR EACH - HB_EnumIndex(), AIns(...,<data>,.T.),
                 ADel(...,.T.) )

2002-11-13 01:07 UTC-0300 Walter Negro <anegro@overnet.com.ar>
  * source/rtl/achoice.prg
  * source/rtl/alert.prg
  * source/rtl/dbsdf.prg
  * source/rtl/menuto.prg
  * source/rtl/persist.prg
  * source/rtl/profiler.prg
  * source/rtl/radiogrp.prg
  * source/rtl/tclass.prg
  * source/rtl/tgetlist.prg
  * source/rtl/tlabel.prg
  * source/rtl/tpopup.prg
  * source/rtl/treport.prg
    * Optimization of code, using FOR EACH and HB_EnumIndex()

2002-11-12 09:22 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * include/hbexprb.c
    ! Fixed support of compile time Upper() to NOT use compile time string sharing.
    + Added optimization HB_EnumIndex() -> HB_P_ENUMINDEX

  * include/hbpcode.h
  * source/compiler/genc.c
  * source/compiler/hbfix.c
  * source/compiler/hbpcode.c
  * source/vm/hvm.c
    + Added support for new HB_P_ENUMINDEX.

2002-11-12 00:45 UTC-0300 Marcelo Lombardo <lombardo@uol.com.br>
  * source/rdd/dbfntx/dbfntx1.c
    ! Fixed ordListAdd for Cl*pper compatibility : "After the new orders
      are opened, the work area is positioned to the first logical record
      in the controlling order"

2002-11-11 01:24 UTC-0300 Walter Negro <anegro@overnet.com.ar>
  * source/vm/itemapi.c
    + add conditional code if !(__DJGPP__) around #include <math.h>

2002-11-08 23:47 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/vm/hvm.c
    ! Fixed reset of Enumeration Var when EXIT used from FOR EACH loop.

  * source/rtl/alert.prg
    - Removed wrong and ugly "fix" to line wrapping in Alert().
    ! Fixed line wrapping, resulting from Enum Var now being a Refernce to the enumerated element.

    /* Luiz, you should NOT attempt to fix code that you clearly don't understand - better ask! */

2002-11-08 22:45 UTC-0300 Luiz Rafael Culik <culikr@uol.com.br>
  * utils/hbmake/hbmake.prg
    ! Added Gauge bar to show compiling progress
  *utils/hbmake/hbmlang.c
    ! added code to display the gauge bar

2002-07-11 02:05 UTC-0300 Walter Negro <anegro@overnet.com.ar>
  * source/rtl/achoice.prg
    ! Fix, if no UDF is set, pressing an alpha key it
      go to first item finding this letter without respecting
      upper and lowercase.
    Reported by Luiz Culik.

2002-11-06 16:45 UTC-0300 Luiz Rafael Culik <culikr@uol.com.br>
  * source/rtl/alert.prg
    ! minor fix to my change from yesterday

2002-11-06 00:00 UTC-0500 Paul Tucker <ptucker@sympatico.ca>
   * makefile.nt
   * makefile.vc
   * make_vc.bat
     * make_vc /? for help
   * contrib/what32
   * contrib/whoo
   * contrib/woopgui
     * simlar treatements.

2002-11-05 21:41 UTC-0300 Luiz Rafael Culik <culikr@uol.com.br>
  * source/rtl/alert.prg
    ! Fixed problem when Text to display has more then 60 chars and the Line Breaker character (;) dont exist
     (You notice this behaviour on some erros produced by xharbour rdd)

2002-11-04 18:19 UTC-0500 Paul Tucker <ptucker@sympatico.ca>
  * makefile.vc
    * no more recursive nmake calls
  * makefile.nt
    * corrected one batch mode call
  * make_vc.bat
    * if building Harbour under NT, will use the alternate makefile.nt
    * for faster builds.
    * if you would prefer not to use batch mode,
    *  run make_vc /y (just like nmake)

2002-11-04 19:30 UTC-0300 Marcelo Lombardo <lombardo@uol.com.br>
  * source/vm/dynsym.c
    ! Fixed workaround for Symbol Table length limited to 10 chars and
    ! Source code comments improved

2002-11-04 09:20 UTC-0300 Marcelo Lombardo <lombardo@uol.com.br>
  * source/macro/macro.y
    + added support for If() function in macro execution with optional 3rd
      parameter, as Cl*pper does : if(<lCondition>,<uResult1> [,<uResult2>])

2002-10-31 17:00 UTC-0300 Walter Negro <anegro@overnet.com.ar>
  * source/rtl/tget.prg
    ! Fix ::DeleteEnd() method.
      It didn't erase the last character.
      Reported by Luiz Rafael Culik.

2002-10-29 21:21 UTC-0500 Paul Tucker <ptucker@sympatico.ca>
  * source/rtl/gtwin/gtwin.c
    * modified by Robert Haley <rhaley@cheshire.net> to allow Tone()
    * to work correctly under Win9x.
    * Win9x Tone() support currently only for Borland and MSVC compilers.
    * The only issue for the moment, is if the calculation of TICKS is
    * incorrect for other compilers.  SEE dTicks in hb_gt_Tone().
    * Someone may wish to adapt the code above hb_gt_tone() in gtwin.c
    * for other compilers.
  * makefile.vc
    * slight re-ordering
  + makefile.nt
  * make_vc.bat
    * if building Harbour under NT, use the alternate makefile.nt
    * for faster builds.

2002-10-29 23:30 UTC-0300 Luiz Rafael Culik <culikr@uol.com.br>
  * source/rtl/memoedit.prg
    source/rtl/teditor.prg
    % CRTL_W key is now an Valid Save key for memoedit Function

2002-10-26 17:30 UTC-0300 Marcelo Lombardo <lombardo@uol.com.br>
  * source/vm/dymsym.c
    + added Workaround for Symbol table lenght limited up to 10 chars
      this can be turned on by defining HB_SYMLIMIT_10_WORKAROUND

2002-10-27 11:30 UTC-0300 Luiz Rafael Culik <culikr@uol.com.br>
  * include/hbapierr.h
    include/hbapirdd.d
    include/hbapi.h
    include/hbvm.h
    include/hbtrace.h
    include/hbdate.h
    include/hbapilng.h
    include/hbapifs.h
    include/hbstack.h
    include/hbset.h
    source/rdd/dbcmd.c
    source/vm/dymsym.c
    source/vm/arrays.c
    source/vm/hvm.c
    source/common/hbtrace.c
    source/common/hbstr.c
    source/common/hbffind.c
    source/rtl/strcase.c
    source/rtl/errorsys.c
    source/rtl/datec.c
    source/rtl/dates.c
    source/rtl/langapi.c
    source/rtl/val.c
    source/rtl/trim.c
    source/rtl/file.c
    source/rtl/filesys.c
    source/rtl/fstemp.c
    Added HB_EXPORT to missing function,(This is to fix problem when liking the xharbour dll with an static library, Example rddads.lib)

2002-10-26 11:30 UTC-0300 Luiz Rafael Culik <culikr@uol.com.br>
  * hrbdll.bc
    ! added missing depencencie pragma.c

2002-10-25 15:00 UTC+0700 Andi Jahja <andijahja@harbour-id.net>
  * include/hbstack.h
    ! modify function prototypes due to exporting functions in source\vm\estack.c - MSVC want them.
  * source/vm/itemapi.c
    ! change: char * HB_EXPORT => char HB_EXPORT * - MSVC want it.
  * include/hbapiitm.h
    ! modify function prototypes due to exporting functions in source\vm\itemapi.c - MSVC want them.

2002-10-24 20:05 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * dll_55.bat
  * hrbdll.bc
    * Modified to include all needed files.

  * source/common/hbstr.c
  * source/pp/pplib.c
  * source/vm/estack.c
  * source/vm/fastitem.c
  * source/vm/itemapi.c
    + Added missing HB_EXPORT qualifier.

  * source/rtl/cstr.prg
    - Removed TraceLog() call.

  * tests/dll_b32.mak
    + Added -DHB_NO_DEFAULT_STACK_MACROS

  - lib/hbdll_bc.lib
    - Removed import lib for BCC since now it can be built with standard make file dll_55.bat

2002-10-24 18:23 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * tests/dll_b32.mak
    * Renamed import lib harbour.lib to hbdll_bc.lib

  + lib/hbdll_bc.lib
    + Added import lib for BCC

2002-10-24 17:47 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * include/hbapi.h
    + Added support for HB_NO_DEFAULT_API_MACROS
  * include/hbstack.h
    + Added support for HB_NO_DEFAULT_STACK_MACROS

  - tests/dll.mak
    - Removed.

  + tests/dll_b32.bat
  + tests/dll_b32.mak
    + Added standard files for creating BCC32 version of xharbour R/T dll [Thanks to Andi].

  * tests/pp_harb.ch
    * Removed direct access to hb_stack.

2002-10-24 10:54 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/vm/arrays.c
    - Removed hb_itemUnRef() in hb_arrayRelease() // Referenced item shoudl NOT be released when Array with reference is released.

  * source/vm/hvm.c
    + Added hb_arrayFill() just before hb_arrayRelease() of s_Globals, so that Globals are properly cleared/released.

  * source/compiler/genc.c
    ! Corrected hb_REGISTERGLOBALS() to register all Globals, not just local ones.

2002-10-22 18:49 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/vm/itemapi.c
    ! Fixed bug in hb_itemStrCmp() when SET EXACT is ON, and not ussing == (and tested string is only spaces).

2002-10-22 15:47 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/vm/macro.c
    ! Corrected initialization of ulValLen before call to hb_memvarGetStrValuePtr().

2002-10-22 13:03 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/vm/hvm.c
    * Changed hb_vmProcessSymbols() to support extensions other than .c for compiled modules.

2002-10-21 23:35 UTC-0300 Walter Negro <anegro@overnet.com.ar>
  * source/common/hbffind.c
    ! Add #include for DJGPP compiler
  * source/rtl/achoice.prg
    ! Reduce redundant code.
    ! Fix default values of nBottom and nRight out of range.
    ! Add control of value of nBottom and nRight.
  * source/rtl/tbrowse.prg
    ! Fixed SetColumnMethod*( that was not using all Display Area
      (The nWidthMax variable was substraced by 2)
      Fixed by Luiz Culik

2002-10-21 18:15 UTC-0500 Paul Tucker <ptucker@sympatico.ca>
  * include/hbdefs.h
    * Added definition for UINT
  * include/hbapigt.h
  * source/rtl/gtapi.c
  * source/rtl/saverest.c
  * source/rtl/xsavescr.c
  * source/rtl/gtdos/gtdos.c
  * source/rtl/gtsln/gtsln.c
  * source/rtl/gtos2/gtos2.c
  * source/rtl/gtwin/gtwin.c
     ! Properly account for the fact that hb_gt_rectsize returns an int
       (ok, so we treat it as UINT, but this is better than USHORT)
  * source/rtl/trace.c
  * source/rtl/errorapi.c
     ! one of these needs to account for a null error message.
     ! I fixed both.  (errInternal)
  + tests/vidtest.prg by Brian Dukes <bdukes@yellowthingy.co.uk>

2002-10-19 19:29 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/rtl/tgetint.prg
    ! Minor fix to __Get()

2002-10-18 18:18 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * include/hbstack.h
    ! fixed definition of hb_stackItemFromBase() to support variable paramaters functions.
    * Changed default to use HB_STACK_MACROS.

  * source/vm/estack.c
    + Added #undef for each of the HB_STACK_MACROS so that functions will be included in R/T, incase used by 3rd party.

2002-10-17 22:11 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * include/hbexprb.c
   ! Fixed hb_compExprUseFunCall() to put reduced value into memory pointed to by pSelf.
     /* This solved GPF under MSVC, and possible other compilers. */

  * source/compiler/exproptb.c
  * source/macro/macrob.c
    * Touched to force recompilation of hbexprb.c (if not doing a CLEAN build).

  * source/compiler/harbour.sly
    + Added missing type casts.

  * source/vm/classes.c
    + Added missing type cast.

2002-10-17 07:56 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * include/hbexprb.c
    ! Fixed GPF when pParms is NULL in hb_compExprUseFunCall()
    ! Fixed typo.

  * source/vm/hvm.c
    * Fixed missing comma.

2002-10-16 21:40 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * include/hbexprb.c
    ! Fixed long standing TODO: Move Function optimizations from hb_compExprNewFunCall() to hb_compExprUseFunCall()

2002-10-16 17:47 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * include/hbexpra.c
    + Added reduction with HB_EA_REDUCE to paramas of functions optimized in hb_compExprNewFunCall().
    ! Fixed compile time optimization of Upper() to support embeded NULL characters in the string.

  * include/hbexprb.c
    + Added compile time optimization of SubStr( "Some Literal", litralNum, literalNum or NIL )

  * source/compiler/harbour.slx
    - Removed few commented lines.

  * source/rtl/minmax.c
    ! Corrected support for Date compared with Non Date in Max() and Min()

  * source/rtl/round.c
    * Reverted recent change to Int()

  * source/vm/macro.c
    ! Corrected call to hb_memvarGetStrValuePtr() to support new optimization of hb_memvarFindSymbol()

  * source/vm/memvars.c
    * Minor correction to trace message.

2002-10-16 12:40 UTC+0700 Andi Jahja <andijahja@harbour-id.net>
  * source/rtl/dircmd.prg
    ! modified output format in function PutNormal()
      previously: pp.exe - dir *.dbf -> test   .db
             now: pp.exe - dir *.dbf -> test.dbf

2002-10-15 21:18 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/pp/ppcore.c
    ! Fixed handling of string delimiters after keyword return in NextName()

2002-10-15 18:17 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * bin/bld.bat
    - Removed refernce to RDDADS.lib and Ace32.lib.

  * source/rtl/round.c
    * Changed Int() to return a long insread of double.

2002-10-15 12:30 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/rtl/version.c
    * Renamed HB_PCODE() to HB_PCODEVER()
    + Added missing extern declaration.

  * source/vm/hvm.c
  * source/vm/memvars.c
    - Removed unused variables assignments.

2002-10-15 15:00 UTC-0300 Marcelo Lombardo <lombardo@uol.com.br>
  * source/vm/hvm.c
    ! Fixed eternal loop when error 1003 is issued and errorsys creates
      the undefined sysmbol and returns ES_RETRY
  * source/vm/memvars.c
    ! __MVPUT : fixed symbol name trailing spaces problem
    ! __MVSCOPE : fixed symbol name trailing spaces problem
    ! hb_memvarFindSymbol() : speed improved and fixed symbol name trailing
                              spaces problem
    ! hb_memvarScope() : speed improved, fixed symbol name trailing
                         spaces problem and removed the second parameter
  * source/vm/macro.c
    ! hb_compMemvarCheck() - hb_memvarScope call parameter adjusted
  * include/hbapi.h
    ! hb_memvarScope prototype - parameter adjusted

2002-10-15 02:00 UTC-0300 Walter Negro <anegro@overnet.com.ar>
  * source/rtl/tget.prg
    ! fixed get (value and display) involving negative with decimal
      number whose value is less than 1, in some pictures.

2002-10-15 10:00 UTC+0700 Andi Jahja <andijahja@harbour-id.net>
   * include/hbapi.h
     + add function prototype: extern char * hb_verPCode( void )
   * source/rtl/version.c
     + add Harbour surface function: HB_PCODE() => Return pCode version info
   * source/common/hbver.c
     + add PCode Version information when user issue -build switch.

2002-10-14 18:52 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * include/hbclass.ch
    * Corrected default scope to nScope.

2002-10-14 16:52 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * include/hbclass.ch
    + Added new HB_CLSTP_PUBLISHED

  * include/hboo.ch
    + Added support for new HB_CLSTP_PUBLISHED
    + Added support for PUBLIC as synonym to EXPORTED.
    + Added support for PRIVATE as synonym to HIDDEN.
    + Added logic to detect and generate Error Message if code uses conflicting SCOPE Qualifers.
    ! Optimized HBCLSCHOICE() - No more multiple nested IIF() in generated code.

2002-10-14 11:17 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/vm/arrays.c
  * source/vm/hvm.c
    ! Fixed support for pushing [non static] string variable by reference.

  * include/hbsetup.h
    * Increased HB_PCODE_VER to 3 because recent change to HB_FS_PUBLIC requires all prg to be recompiled.
  * source/vm/hvm.c
    * Made PCODE version Error Message more user friendly.

2002-10-13 11:41 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/rtl/win32ole.prg
    + Added support for End() method calls into OnError()

2002-10-13 11:04 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * include/hbvmpub.h
    * Changed #define HB_FS_PUBLIC to: ( ( HB_SYMBOLSCOPE ) 0x01 )

  * include/hbcomp.h
  * source/compiler/harbour.c
    * Added 3rd paramater bAlias to to void hb_compGenPushSymbol( char * szSymbolName, BOOL bFunction, BOOL bAlias );

  * include/hbexprb.c
  * include/hbmacro.h
  * source/compiler/genc.c
  * source/compiler/harbour.sly
  * source/vm/macro.c
    + Added 3rd paramater to all calls to hb_compGenPushSymbol()

  * source/vm/dynsym.c
  * source/vm/hvm.c
    * Fixed hb_vmProcessSymbols() to correctly support HB_FS_PUBLIC flag.

  * source/rdd/dbcmd.c
    * Formating.

2002-10-12 22:50 UTC-0300 Luiz Rafael Culik <culikr@uol.com.br>
   * contrib/hbzlib/*
     ! Updated all source to take advantage of new ziparchive function
     ! Fixed also some memory leak on unziping functions
   - adler32.c compress.c crc32.c deflate.c deflate.h gvmat32c.c gzio.c infblock.c infblock.h infcodes.c infcodes.h inffast.c inffast.h inffixed.h inflate.c inftrees.c inftrees.h infutil.c infutil.h maketree.c trees.c trees.h uncompr.c
     ! This Files are now in zlib dir
   + Linux/*
       The Files necessary to compile hbzlib on linux.
   + Licence.txt
       The license of Ziparchive Library

2002-10-11 21:35 UTC-0300 Horacio Roldan <harbour_ar@yahoo.com.ar>
   * include/hbapirdd.h
   * include/hbrdddbf.h
   * include/hbrddcdx.h
   * include/hbrddntx.h
   * source/rdd/dbcmd.c
   * source/rdd/workarea.c
   * contrib/rdd_ads/ads1.c
   * contrib/rdd_ads/rddads.h
        + Changed fieldname max length handling,
          it is now a workarea property. (set by the RDD)
          (in ADS, this is just a patch)

   * source/rdd/dbfcdx/dbfcdx1.h
   * source/rdd/dbfcdx/dbfcdx2.h
   * source/rdd/dbfcdx/dbfcdx1.c
        ! fixed bug reported by Richard Chidiak
        + added function hb_cdxMacroRun
        ! fixed bug reported by Peter Rees.
        * changed index creation and updating:
          some spaces in keys aren't compressed now, so ADS can read
          the indexes. (it couldn't with some special keys)

   * dbcmd synched with Harbour:
    2002-10-04 14:42 UTC+0300 Alexander Kresin <alex@belacy.belgorod.su>
      * source/rdd/dbcmd.c
        ! Bug fixed in COPY TO, APPEND FROM with aliased fields

   * dbfntx synched with Harbour:
    2002-10-04 15:552 UTC+0300 Alexander Kresin <alex@belacy.belgorod.su>
      * source/rdd/dbfntx/dbfntx1.c
        ! Bug fixed in key appending with few open indexes
    2002-10-04 13:58 UTC+0300 Alexander Kresin <alex@belacy.belgorod.su>
      * source/rdd/dbfntx/dbfntx1.c
        ! Few bugs fixed, related to OrdKeyNo() and OrdKeyCount()

   * rdd_ads synched with Harbour:
      * contrib/rdd_ads/*.*
        * copied from Harbour
     2002-10-03 0:40 UTC-0800 Brian Hays <bhays@abacuslaw.com>
      * contrib/rdd_ads/ace.h
        + added (void) to AdsApplicationExit( void );
                This removes a compiler warning about missing the prototype.
                Let me know if this creates a problem with any other compilers.
      * contrib/rdd_ads/adsfunc.c
        + added AdsGetLastError() contrib. by Randy Portnoff (Thanks!)
      * contrib/rdd_ads/ads1.c
        * Cleaned up adsPutValue and adsGetValue formatting,
        * Fixed fieldname length references
        * Removed errant setting of uiLen in adsGetValue since these
                are set in adsOpen now.
        * adsOrderInfo(DBOI_KEYVAL): fixed ntx handling of numerics
                Added special decoding for keys of Negative values.
        * adsCreate: fixed fielddefs buffer sizing
        * adsOpen: fixed fieldname length references
                        set uiLen of extended types
        * adsInfo: reformatted, prepared for fleshing out the rest
                of the options.
                Added support for dbinfo(DBI_ISFLOCK)

2002-10-10 09:43 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/vm/arrays.c
  * source/vm/hvm.c
    + Added FOR EACH support for STRINGs.

2002-10-09 13:40 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/compiler/harbour.sly
    + New token EPSILON
    * Modied Function and Procedure definition to allow new Syntax:
         FUNCTION Foo( ... )
         PROCEDURE Foo( ... )
      - Variable paramaters functions are flags as 255 paramaters.

  * source/compiler/harbour.slx
    + Added support for new token EPSILON

  * source/compiler/harbour.c
    + Added logic to avoid paramater count correction when 255.
    + Added logic to generate error if more then 255 locals, or params, since HB_P_FRAME supports only BYTE for each.

  * include/hberrors.h
    + #define HB_COMP_ERR_TOOMANY_PARAMS              58
  * source/compiler/hbgenerr.c
    + "Too many Paramaters declarations \'%s\'."

  * include/hbapi.h
  * source/vm/estack.c
  * source/vm/extend.c
  * source/vm/arrays.c
  * source/vm/fastitem.c
  * source/vm/hvm.c
  * source/vm/pcount.c
    + Added support for variable number paramaters <...> in functions.
      - Actual number of paramaters signified as 256 + actual paramaters.
      - Related logic offset LOCALs access when .paramcnt > 255 ( + .paramcnt - 256 ).

  * source/pp/ppcore.c
    * Corrected type cast.

  + tests/varparam.prg
    + New test demo of new Varaiable Pararmeters in Functions.

2002-10-09 04:53 UTC+0200 Przemyslaw Czerpak <druzus@polbox.com>
  * source/rtl/gtwin/gtwin.c
    * An attempt to fix cursor hiding problem again :-)
      It eliminates one call to slow WinConsole subsystem
      and makes the 'NORMAL' cursor shape more similar to DOS one.

  * include/hbapi.h
  * source/rtl/accept.c
  * source/rtl/console.c
    * Fixed ACCEPT to respect SET CONSOLE and similar sets.
    * hb_conOutAlt() is global function now.

2002-10-08 14:25 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * tests/pp.prg
    * Fixed initialization of cLastChar in NextIdentifier()

2002-10-08 14:30 UTC+0100 Marek Paliwoda <paliwoda@inetia.pl>
  * source/rtl/gtwin/gtwin.c
    * An attempt to fix cursor hiding problem

2002-10-07 08:15 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/vm/arrays.c
    ! Fixed memory leak in hb_arrayGetByRef()
  * source/vm/hvm.c
    - Defed out, section not realy needed.

2002-10-06 14:22 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
   * source/rtl/cstr.prg
     + Added new function StrToVal( cString, cType )
     + Added new function StrToPrg( xVal )

   * contrib/xVisual/FormEdit.Prg
     * Using new StrToPrg in XFMReflection()

   * include/hbapi.h
     + Added extern PHB_FUNC hb_objGetMthd( PHB_ITEM pObject, PHB_SYMB pSymMsg, BOOL bAllowErrFunc );
   * source/vm/hvm.c
     * Changed hb_objGetMethod() to hb_objGetMthd()

   * source/vm/classes.c
     + Added new function __CLSMSGASSIGNED( nClassH, cMsg ) to return .F. if Message is Virtual or does not exist.

2002-10-05 23:00 UTC-0300 Luiz Rafael Culik <culikr@uol.com.br>
  * source/rtl/tget.prg
    * Fixed small problem when using Mouse to select the editing get

2002-10-05 16:26 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * include/hbapi.h
  * source/vm/arrays.c
    + Added new hb_arrayGetByRef() - just like hb_arrayGet() but gets the item By Ref.

  * source/vm/hvm.c
    * Changed HB_P_ENUMERATE to use new hb_arrayGetByRef()
      /* Now FOR EACH enumrator can be assigned to and assignment will be reflected into the respective element. */

  * source/rtl/objfunc.prg
    + Added new __objGetValueDiff( oBase, oObject )
      Return 2 Dim Array of Properties and Values of just modified values, between the Base and the Object.

  * contrib/xVisual/FormEdit.Prg
  * contrib/xVisual/xInspect.prg
  * contrib/xVisual/xide.prg
    + Started XFM support.

2002-10-05 09:18 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/vm/classes.c
    ! Fixed bug in __CLSDELMSG() Inline method, should be cleared but not deleted.

2002-10-05 01:57 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/vm/hvm.c
    + Added new PRG function HB_QSelf() to retuen the correct SELF object, even if called from a Codeblock.

2002-10-05 01:15 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/vm/classes.c
    * Modified __CLSMODMSG() to allow conversion from Block to Method, or vice versa.

  * contrib/Whoo/source/TWindow.prg
    * Renamed method SetBlock() to SetMethod().
      It may now override or add the method, and set it to either a block or a function pointer

  * source/rtl/objfunc.prg
    + Added __objSetMethod( oObject, cMsg, FuncOrBlock, nScope )
      It will override or add the requested method of the specified object, with either a block or function pointer.

  + tests/setmethd.prg
    + New test to demonstrate the above additions.

2002-10-04 23:00 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/vm/hvm.c
    + Added new PRG function HB_QWith() to retuen the WITH object (equivalent to : by itself, which is not supported).

  + contrib/xVisual/xide.ch
    + New include file to be used by xIDE generated code.
      Added support for nested:

        CONTROL <control> FROM <class>
          :property := <value>
          [...]
        END CONTROL

      within the form class declaration.

2002-10-04 17:30 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/rtl/objfunc.prg
    + Added support support for a 3rd optional paramter nScope in __objAddData()

2002-10-04 11:15 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/rtl/objfunc.prg
    ! Rewrote __objGetMsgList and __objGetValueList
    + Added support support for an optional paramter nScope to __objGetMsgList() all other functions that call it.

  * source/vm/classes.c
    + Added support support for a 2nd optional paramter uiScope in hb___msgClsSel()

  + tests/objlist.prg
    + Added demo for new SCOPE paramater and usage of __objGetValueList()

2002-10-03 08:50 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/rtl/win32ole.prg
    + Added support for few additional VT_* types (Thanks to José F. Giménez <jfgimenez@wanadoo.es>)

2002-10-01 17:20 UTC-0300 Luiz Rafael Culik <culikr@uol.com.br>
  * source/rtl/dbsdf.prg
    * Changes to support Rddads extended fields type whe using append from

2002-10-01 19:30 UTC+0100 Marek Paliwoda <paliwoda@inetia.pl>
  * source/rtl/gtwin/gtwin.c
    * Fixes suggested by Peter Rees <peter@rees.co.nz>. Thanks Peter !
    * Added Copyright notes for hb_gt_CtrlHandler(), hb_gt_ReadKey()
      and hb_gt_Tone(), previously omited by mistake

2002-10-01 08:30 UTC+0700 Andi Jahja <andijahja@harbour-id.net>
   * source/rtl/tget.prg
     ! Change behaviour of function UPDATED() to conform with Clipper which
       will return .T. if a key press is succesfully accepted even the
       value of the get is not changed. This was done by assigning .T.
       in ::OverStrike() and ::Insert().
       Thanks to "Peter Rees" <peter@rees.co.nz> for good observation.

2002-09-30 14:35 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * include/hberrors.h
    + Added: #define HB_PP_ERR_TOO_MANY_MARKERS              20

  * source/pp/ppcore.c
    + Added logic for new fatal error: "Too many match markers in #translate or #command"
    * Increased PATTERN_SIZE to 4096

2002-09-30 00:25 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/compiler/harbour.sly
    + Added support for varaibales and functions by refernce as paramaters for IIF()

  * source/pp/ppcore.c
    * Formatting.

2002-09-29 12:00 UTC+0700 Andi Jahja <andijahja@harbour-id.net>
  * source/rtl/tget.prg
    ! fixed get (value and display) involving negative (with decimal)
      number whose value is less than 1.

2002-09-28 21:50 UTC-0300 Horacio Roldan <harbour_ar@yahoo.com.ar>
   * source/compiler/hbusage.c
        ! fixed a bug in the list of hb_compPrintCredits ;-)

2002-09-28 14:00 UTC+0100 Marek Paliwoda <paliwoda@inetia.pl>
  * source/rtl/gtwin/gtwin.c
    * FWH GPF fixes provided by Przemyslaw Czerpak <druzus@polbox.com>.
      New, fixed version should work OK with FWH. Please note that old
      version of gtwin could produce random GPFs because of improper
      initialization when run with FWH.
      Again MANY THANKS to Przemek for his really amazing work.

2002-09-28 09:00 UTC+0100 Marek Paliwoda <paliwoda@inetia.pl>
  * source/vm/itemapi.c
    * Fixed GPF when NaN values were converted to string (under linux)

2002-09-28 02:10 UTC-0300 Horacio Roldan <harbour_ar@yahoo.com.ar>
   * source/rdd/dbfcdx/dbfcdx1.c
        ! fixed error reported by Gianni Santamarina.

2002-09-27 22:45 UTC+0100 Marek Paliwoda <paliwoda@inetia.pl>
  * source/rtl/gtwin/gtwin.c
    * New, highly optimized Windows console gt driver
      written by Przemyslaw Czerpak <druzus@polbox.com>
          (Many Thanks Przemek)

  * source/rtl/gtcgi/gtcgi.c
  * source/rtl/gtcrs/gtcrs.c
  * source/rtl/gtdos/gtdos.c
  * source/rtl/gtos2/gtos2.c
  * source/rtl/gtpca/gtpca.c
  * source/rtl/gtstd/gtstd.c
    * Fixed bug in hb_gt_Box() found by Przemyslaw Czerpak (Thnx)

  * source/rtl/gtsln/gtsln.c
    * Fixed screen flushing when OutErr() was used
    * Fixed bug in hb_gt_Box() found by Przemyslaw Czerpak
    * Fixed double hb_gt_DispEnd() in hb_gt_Box() found by Przemyslaw Czerpak

  * config/linux/gcc.cf
    * Added support for ccache (caching compile results)

  * source/rtl/tbrowse.prg
    * Synched with Harbour - many fixes from Maurilio Longo

2002-09-27 08:57 UTC-0300 Horacio Roldan <harbour_ar@yahoo.com.ar>
   * source/rdd/dbfcdx/dbfcdx1.h
   * source/rdd/dbfcdx/dbfcdx1.c
        ! changed key in-memory management.
          this fixes trimmed key problems, reported by Lorenzo Fiorini.

2002-09-27 08:56 UTC-0300 Horacio Roldan <harbour_ar@yahoo.com.ar>
   * include/hbrddntx.h
   * source/rdd/dbfntx/dbfntx1.c
        ! synched with Harbour,
        several fixes from Alexander Kresin.

2002-09-26 19:42 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/pp/ppcore.c
    * Formating.

  * source/vm/arrayshb.c
    * Added support for 3rd paramater lAutoShrink to aDel()

2002-09-26 13:00 UTC -0300 Luiz Rafael Culik <culikr@uol.com.br>
  * contrib/rdd_ads/ace.h
    * removed typedef for UCHAR and UNIT
  * contrib/rdd_ads/adsfunc1.c
    contrib/rdd_ads/adsmgmnt.c
    * changed UCHAR to UNSIGNED8 , UINT to int

2002-09-25 15:25 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * tests/pp.prg
    * Added logic to set/restore action for key Up/Down in DOT mode.

2002-09-25 11:55 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/pp/ppcore.c
    ! Fixed bug hb_pp_ParseExpression() which caused redundant processing.

  * tests/pp.prg
    + Added logic to output #directives produced by results into the pp$ file, like Clipper 5.3

2002-09-23 21:22 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/vm/hvm.c
    + Added logic to support a RETURN from inside a WITH OBJECT block.

2002-09-23 20:25 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/pp/ppcore.c
    ! Fixed long oustanding issue of correct support for \ (escape) in pre-processor rules.

  * include/hbclass.ch
    + Added missing escapes in nested directives.

  * include/hbexpra.c
    + Added compile time optimization of Upper() when applied to a literal.

  * source/vm/hvm.c
    + Added logic to support a RETURN from inside a FOR EACH loop.

  * tests/pp.prg
    + Added support for \\ (double esacpe).
    ! Fixed possible infinite loop when marking match marker as repeatable.

2002-09-23 10:50 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * include/hbapi.h
  * source/vm/hvm.c
    + Added void hb_vmRegisterGlobals( PHB_ITEM **pGlobals, short iGlobals )

  * source/compiler/genc.c
    * Changed generation of hb_REGISTERGLOBALS() to call new hb_vmRegisterGlobals()

  * source/vm/hvm.c
    * Modified HB_ITEM hb_vm_aGlobals to static HB_ITEM s_aGlobals.
    + Added hb_arrayRelease( &s_aGlobals ) to hb_vmQuit()
    + Added HB_FUNC( __VMVARGLIST ) returns clone of Globals Array.

  * source/compiler/harbour.c
    - Removed generation of hb_RELEASEGLOBALS()

  * source/compiler/harbour.sly
    + Added Static Intialization check on values used to initialize GLOBALS.

2002-09-22 17:38 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * include/hbpcode.h
  * source/compiler/hbpcode.c
  * source/compiler/genc.c
  * source/compiler/harbour.c
  * source/compiler/hbfix.c
  * source/vm/hvm.c
    + Readded support for HB_P_PUSHGLOBALREF

  * source/vm/hvm.c
    +  Added HB_ITEM hb_vm_aGlobals - Harbour array to register all GLOBALS for GC.

  * source/compiler/genc.c
    * Changed _RELEASEGLOBALS to hb_RELEASEGLOBALS
    + Added support for auto generated hb_REGISTERGLOBALS to register module globals into hb_vm_aGlobals.

  * include/hbapi.h
  * source/vm/hvm.c
    + Added hb_vmIsGlobalRef()

  * source/vm/garbage.c
    + Added hb_vmIsGlobalRef() to sweep scan.

  * tests/global1.prg
    + Readded sample of passing Global by reference.

  * tests/pp_harb.ch
    * Removed extra paramater in call to hb_itemUnRef().

2002-09-21 09:34 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/rdd/dbf1.c
  * source/rdd/dbfcdx/dbfcdx1.c
  * source/vm/garbage.c
    ! Corrected few typos discovered by MSVC

2002-09-21 13:50 UTC+0100 Marek Paliwoda <paliwoda@inetia.pl>
  * ChangeLog
    * Fixed ChangLog entry for my last commit

  * doc/en/gtslang.txt
    * Synchronized with last gtsln improvements

2002-09-20 22:19 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/vm/arrays.c
  * source/vm/classes.c
  * source/vm/codebloc.c
  * source/vm/extend.c
  * source/vm/garbage.c
  * source/vm/hvm.c
  * source/vm/itemapi.c
  * source/vm/memvars.c
  * include/hbapi.h
  * include/hbapiitm.h
  * include/hbvmpub.h
  * tests/pp_harb.ch
    < Reverted last change related to bNeedLock, hb_itemUnRef() and exclusion of statics from GC.

  * include/hbpcode.h
  * source/compiler/genc.c
  * source/compiler/hbfix.c
  * source/compiler/hbpcode.c
  * source/vm/hvm.c
    - Removed support for HB_P_PUSHGLOBALREF

  * source/compiler/harbour.c
    + Added Error on attempting to pass a GLOBAL by refrence.

  * source/pp/ppcore.c
    ! Fixed bug with support of X in #[X]command and #[X]translate if abbreviation used.
    - Removed support for #unxcommand and #unxtranslate.
    * Finalized implementation of [x]uncommand and [x]untranslate.
      /*
          NOTE: #uncommand and #untranslate do NOT require MATCH specification [nor RESULT specification] the KEY itself is sufficient.
               #Xuncommand and #Xuntranslate DO require correct MATCH specification, but do NOT require RESULT specification.

          IOW:
               1. #uncommand will search a matching most recent #[x]command based on the KEY only, and will remove it if found.
               2. #untranslate will search a matching most recent #[x]translate based on the KEY only, and will remove it if found.
               3. #Xuncommand will search a matching most recent #[x]command based on the KEY, AND Match Rule, and will remove it if found.
               4. #Xuntranslate will search a matching most recent #[x]translate based on the KEY, AND MatchRule, and will remove it if found.

       */

  * tests/global1.prg
    - Removed sample of Global passed by refernce.

2002-09-20 23:40 UTC -0300 Luiz Rafael Culik <culikr@uol.com.br>
  * utils/hbmake/hbmake.prg
    * Minor changes.
        - The select Main file, only allow to select between all files need by the app
        - The select main file is now sorted

2002-09-20 12:44 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * include/hbapi.h
    * Changed hb_vmGlobalLock() to a macro HB_ITEM_LOCK()
    * Changed hb_vmGlobalUnlock() to a macro HB_ITEM_UNLOCK()

  * include/hbvmpub.h
    + Added member bNeedLock to hb_struRefer

  * include/hbapiitm.h
  * source/vm/itemapi.c
    * Changed hb_itemUnRef() to accept 2nd paramater pointer to BOOL.

  * source/vm/arrays.c
  * source/vm/classes.c
  * source/vm/codebloc.c
  * source/vm/extend.c
  * source/vm/garbage.c
  * source/vm/hvm.c
  * source/vm/memvars.c
  * tests/pp_harb.ch
    * Changed all hb_itemUnRef() calls to pass 2nd paramater pointer to BOOL, or NULL.

  * source/vm/memvars.c
  * source/vm/hvm.c
    + Added logic to HB_ITEM_UNLOCK given STATIC and GLOBAL just before assignment, and HB_ITEM_LOCK just after assignment.
    + Added logic to HB_ITEM_UNLOCK given VAR just before assignment, and HB_ITEM_LOCK just after assignment -
      if VAR the De-Refernce VAR is a GLOBAL or STATIC.

  * source/vm/hvm.c
    + Added logic to mark a variables pushed by refernce asRefer.bNeedLock as TRUE for GLOBALs and STATICs and FALSE for LOCALs
      /* MEMVARs don't use asRefer. */
    + Added LOCK to s_aStatics.
    + Added UNLOCK to all s_aStatics elements in hb_vmQuit().

  * source/vm/garbage.c
    - Removed hb_vmIsStaticRef() from sweep scan, since STATIC should no longer require garbage collection.

  /*
     NOTE: Garbage collection should be much faster, and thus applications which have frequent calls to HB_GCALL()
           (like FWH) should be noticably faster after this change. I tested heavily, but will appreciate extensive
           testing, [and reports] from everyone.
   */

2002-09-20 21:10 UTC+0100 Marek Paliwoda <paliwoda@inetia.pl>
  * include/hbapigt.h
  * source/rtl/console.c
  * source/rtl/gtapi.c
  * source/rtl/gtcgi/gtcgi.c
  * source/rtl/gtcrs/gtcrs.c
  * source/rtl/gtdos/gtdos.c
  * source/rtl/gtos2/gtos2.c
  * source/rtl/gtpca/gtpca.c
  * source/rtl/gtstd/gtstd.c
  * source/rtl/gtwin/gtwin.c
    * Fixed long waiting problem with OutStd()/OutErr()
      (gt layer can now track OutStd()/OutErr() usage)

  * source/rtl/gtsln/gtsln.c
  * source/rtl/gtsln/gtsln.h
  * source/rtl/gtsln/keytrans.c
    * Fixed problem with OutStd()/OutErr() redirected
        to a file (MANY THANKS to Przemyslaw Czerpak
        for detailed information on how to do that)
    * Fixed long waiting problem with OutStd()/OutErr()
        (gt layer can now track OutStd()/OutErr() usage)
    * Fixed broken logic in gtsln keyboard handling

2002-09-19 18:00 UTC-0300 Luiz Rafael Culik <culikr@uol.com.br>
   * source/rtl/tbrowse.prg
     Changed    ::aSetStyle       := ARRAY( 4096 ) to    ::aSetStyle       := ARRAY( 5 )
   * source/rtl/tbcolumn.prg
     Changed ::aSetStyle := ARRAY( 4096 ) to    ::aSetStyle := ARRAY( 3 )

2002-09-19 00:35 UTC-0300 Horacio Roldan <harbour_ar@yahoo.com.ar>
   * source/rdd/dbfcdx/dbfcdx2.h
   * source/rdd/dbfcdx/dbfcdx1.c
        + added function hb_cdxGetTagNumber
        ! fixed some castings and warnings reported by
          Larry Sevilla, Luiz and Andy.
        ! fixed controlling order after ordCreate()
        ! fixed controlling order after ordListAdd()
          This fixes the controlling order after:
          USE name INDEX name
          SET INDEX TO name
          INDEX ON key TAG tagname
   * source/rdd/dbcmd.c
        ! fix gpf in pack, reported by Jorge Mason.
   * source/rdd/dbf1.c
        + added support for DBI_FULLPATH and DBI_SHARED,
          sent by Gianluca Piemonte.

2002-09-18 18:55 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * include/hbvmpub.h
    + Added HB_ITEM related definitions (moved from hbapi.h, which calls hbvmpub.h)
    - Removed iGlobals memeber from _HB_CODEBLOCK
    * Changed defintion of hb_vmExecute() to accept 3rd paramater PHB_ITEM** pGlobals.

  * include/hbapi.h
    - Moved HB_ITEM related definitions to hbvmpub.h

  * include/hbsetup.h
    * Increased #define HB_PCODE_VER to 2

  * include/hbvm.h
    * Changed defintion of hb_vmExecute() to accept 3rd paramater PHB_ITEM** pGlobals.

  * source/vm/codebloc.c
  * source/vm/hvm.c
  * source/vm/macro.c
    * Changed all calls to hb_vmExecute() to pass the correct pGlobal as 3rd parameter.
    - Removed hb_vmpGlobals and related logic.

  * source/vm/maindllp.c
    * Changed defintion of hb_vmExecute() to accept 3rd paramater PHB_ITEM** pGlobals.

  * source/compiler/genc.c
    * Changed generation of PCODE to pass &pGlobals as 3rd parameter to hb_vmExecute().

  * source/rtl/win32ole.prg
    - Commented unused variable.

  * tests/global1.prg
  * tests/global2.prg
    * Modified to test use of passing a Global in block to a module where the global is NOT declared.
    * Modified to test use of passing a Global by refernce to a module where the global is NOT declared and being modified.

/*
   WARNING!!! All PRG files MUST be recompiled!!!
              Users of FWH, must use the supplied MAKE5HX.bat to recompile FiveHX.lib!!!
*/

2002-09-17 19:59 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/compiler/genc.c
  * source/compiler/harbour.c
    ! Fixed reset of hb_comp_pGlobals, hb_comp_iGlobals for multi-file compilation.

2002-09-17 15:23 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/vm/codebloc.c
    - Commented hb_gcLock/Unlock logic before after calls to hb_vmExecute().
  * source/vm/hvm.c
    - Commented hb_gcLock/Unlock logic before after calls to hb_vmExecute().
    + Added hb_gcLock/Unlock at HB_P_POPGLOBAL.
    + New functions hb_vmGlobalLock() and hb_vmGlobalUnlock().

  * include/hbapi.h
    + extern void hb_vmGlobalLock( PHB_ITEM pGlobal ); /* hvm.c - Calls hb_gcLock(...) when needed. */
    + extern void hb_vmGlobalUnlock( PHB_ITEM pGlobal ); /* hvm.c - Calls hb_gcUnlock(...) when needed. */

  * source/vm/garbage.c
    - Commented hb_vm_pGlobals processing in sweep.

  /*
     NOTE: C code which directly modify GLOBAL var, should first call hb_vmGlobalUnlock()
           and after assignment call hb_vmGlobalLock().
   */

2002-09-17 11:07 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/vm/codebloc.c
  * source/vm/hvm.c
    * Added hb_gcLock() on current globals before executing nested call, and hb_gcUnlock() after such execution.

2002-09-16 23:26 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/compiler/harbour.slx
    * Changed WANTS_EXP (REJECT_OP) to NOT reject : as it may be a valid WITH expression.
    ! Minor optimization for GLOBAL{WS}EXTERAM and WITH{WS}OBJECT.

2002-09-16 22:50 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * include/hbpcode.h
  * source/compiler/genc.c
  * source/compiler/harbour.c
  * source/compiler/hbfix.c
  * source/compiler/hbpcode.c
    + Added support for new HB_PUSHGLOBALREF
    + Added PHB_ITEM *pLiveStorage to shadow pGlobals because BCC can't support &pGlobals
     (apparantly because the static array is saved as constant ) so &pLiveStorage is used instead.
    * Modified usage of hb_vm_pGlobals from PHB_ITEM* to PHB_ITEM** required for new GLOBAL by refernce support.

  * include/hbapi.h
    + Added members pGlobals and iGlobals to _HB_CODEBLOCK

  * source/vm/codebloc.c
    + Added support for GLOBALS refrenced in CodeBlocks.

  * source/vm/hvm.c
    + Added hb_vmPushGlobalByRef() to support new HB_P_PUSHGLOBALREF.
    * Modified usage of hb_vm_pGlobals from PHB_ITEM* to PHB_ITEM** required for new GLOBAL by refernce support.

  * source/vm/garbage.c
    * Modified usage of hb_vm_pGlobals from PHB_ITEM* to PHB_ITEM**

2002-09-16 13:30 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * tests/global1.prg
    * Modified to demonstrate sharing and usage of GLOBAL variables from C code.

2002-09-16 11:13 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * makefile.vc
    + Added /FORCE:MULTIPLE to switches used to build hbmake.exe to overcome link error.

  * bin/bld.bat
    + Added 2nd prg support to MSVC, and corrected typo.

  * source/compiler/genc.c
  * source/pp/ppcore.c
    + Added missing ; required by MSVC.

  * source/rdd/dbfcdx/dbfcdx1.c
    + Added type casts required by MSVC.

2002-09-15 22:31 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * include/hbcomp.h
  * include/hbpcode.h
  * source/vm/hvm.c
  * source/compiler/genc.c
  * source/compiler/hbfix.c
  * source/compiler/hbpcode.c
  * source/compiler/harbour.c
    + Added support for new HB_P_PUSHGLOBAL and HB_P_POPGLOBAL.

  * source/compiler/harbour.slx
  * source/compiler/harbour.sly
    + Added support for new syntax:
      GLOBAL <Var> [ := <exp> ] [,...]
      GLOBAL <Array> \[ <length>\] [,...]
      GLOBAL EXTERNAL <Var> [,...]

:13 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * makefile.vc
    + Added /FORCE:MULTIPLE to switches used to build hbmake.exe to overcome link error.

  * bin/bld.bat
    + Added 2nd prg support to MSVC, and corrected typo.

  * source/compiler/genc.c
  * source/pp/ppcore.c
    + Added missing ; required by MSVC.

  * source/rdd/dbfcdx/dbfcdx1.c
    + Added type casts required by MSVC.

2002-09-15 22:31 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * include/hbcomp.h
  * include/hbpcode.h
  * source/vm/hvm.c
  * source/compiler/genc.c
  * source/compiler/hbfix.c
  * source/compiler/hbpcode.c
  * source/compiler/harbour.c
    + Added support for new HB_P_PUSHGLOBAL and HB_P_POPGLOBAL.

  * source/compiler/harbour.slx
  * source/compiler/harbour.sly
    + Added support for new syntax:
      GLOBAL <Var> [ := <exp> ] [,...]
      GLOBAL <Array> \[ <length>\] [,...]
      GLOBAL EXTERNAL <Var> [,...]

  * include/hberrors.h
  * source/compiler/hbgenerr.c
    + Added new error messages:
        "Misplaced Global declaration \'%s\'.",
        "Too many Global declarations \'%s\'.",
        "External Global declaration can not include initializer \'%s\'."

  * source/vm/garbage.c
    + Added hb_vm_pGlobals to sweep.

  /*
     NEW Global Variables are much like STATICs only much FASTER. The added benefit, is that GLOBAL variables
     can be shared between different modules like PUBLIC variables, but with the speed and efficency of declared
     variables. For example, file1.prg may declare:

        GLOBAL MyGlobal

     and File2.prg might gain access, by declaring:

        GLOBAL EXTERNAL MyGlobal

     both files may now utilize MyGlobal throught all of the functions of both files.
   */

  + tests/global1.prg
  + tests/global2.prg
    + New demo files for the new GLOBAL and GLOBAL EXTERNAL syntax and usage.

  * bin/bld.bat
    * Modified to support build of 2 files.

    /* Please note -P -W are always included, so that extra parameter can be a prg name instead of compiler switch!!! */

  * tests/pp.prg
    * Fixed CompileRule to support same marker used more than once in match rule.

2002-09-07 00:30 UTC-0300 Luiz Rafael Culik <culikr@uol.com.br>
  * Source/rtl/tget.prg
       Added missing Caption DATA and init to ""
  * contrib/rdd_ads/adsfunc.c
    ! removed function That required Aceaapi version >= 6.xx that Call AdsDDAddTable

2002-09-06 17:50 UTC+0700 Andi Jahja <andijahja@harbour-id.net>
  * source/rtl/math.c
    * Fixed typo
    Now BCC hbtest.exe's errors returns to 107

2002-09-06 17:30 UTC+0700 Andi Jahja <andijahja@harbour-id.net>
  Following changes are for new math error handler borrowed from Harbour:
  ( in order to enable xHarbour users to use functions in libct.lib )
  * source/vm/itemapi.c ( hb_itemPutNDLen, hb_itemStr )
    2002-07-07 22:40 UTC+0100 Martin Vogel <vogel@inttec.de>
       * source/vm/itemapi.c
         * bug fix: app compiled with BCC crashed if hb_itemPutNDLen was called with a "NaN" double
         * BCC checks for infinity added in hb_itemStr
         * possible bug fixed: math handler has not been switched off before using log(0) in hb_itemStr
  * source/rtl/math.c
  * include/hbmath.h
  * tests/mathtest.prg
  + include/math.ch

  BCC hbtest.exe increased from 107 to 108 because of :

  ? str(log(-1))

     Previously: "***********************"
            Now: "*********************************************************************************************"

  !!-- IMPORTANT NOTE --!!
  !!! Synchronization was tested on BCC and MSVC only !!!

2002-09-05 21:15 UTC-0300 Luiz Rafael Culik <culikr@uol.com.br>
   * contrib/rdd_ads/ads1.c
     ! Fixed Support for Long fields names in adscreate
     ! Fixed Display for the follow type of fields when ADT format is USED
       Autoinc -> 10
       Double/Curdouble 8(Official Size of field on Database)+2*HB_SET_DECIMALS value

2002-09-05 18:46 UTC-0300 Horacio Roldan <harbour_ar@yahoo.com.ar>
   * include/hbrddcdx.h
   * source/rdd/dbfcdx/dbfcdx1.c
   * source/rdd/dbfcdx/dbfcdx1.h
   * source/rdd/dbfcdx/dbfcdx2.h
     + added support for creating big indexes
     hb_cdxSortSwapSavePage, hb_cdxSortSwapFillPage,
     hb_cdxSortSwapRecurseDict, hb_cdxSortSwapSendWord
     hb_cdxSortSwapBuildIndex, hb_cdxSortSwapGetNextKey;
     + added hb_cdxKeyValCompare
     ! fixed hb_cdxKeyGetItem for numeric keys
     ! fixed hb_cdxTagExtNodeWrite
     ! renamed some structs because td was confused

2002-09-04 12:05 UTC-0300 Luiz Rafael Culik <culikr@uol.com.br>
   * source/rtl/teditot.prg
     ! fixed line splitting when a character is deleted from a line and there is a
       word wrapping limit. Please note that lines of text are treated differently
       from the way clipper 5.x treats them, in particular when past EOL there is no
       deletion from current line
   * source/rtl/memoedit.prg
     ! fixed cursor positiong and shaping when calling an user function
   *Both Fixed By Maurilio Longo

2002-09-02 21:30 UTC-0300 Luiz Rafael Culik <culikr@uol.com.br>
   * source/rtl/tbrowse.prg
     !!! Reverted to previus version

2002-09-02 13:00 UTC-0300 Luiz Rafael Culik <culikr@uol.com.br>
   * source/rtl/tbrowse.prg
     *Sync with follow harbour change
   * harbour/source/rtl/tbrowse.prg
     ! fixed columns' width calulation on ::SetColumnWidth( oCol ) method

2002-08-31 20:38 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/rdd/dbf1.c
    ! Fixed hb_dbfLockFile() to release record locks before attempting to lock the file.

2002-08-30 21:50 UTC-0300 Luiz Rafael Culik <culikr@uol.com.br>
  * source/rtl/tget.prg
    ! Added Missing Caption Data
  * source/rtl/tbcolumn.prg
    ! Defaults ::Colsep to Nil (Somehow This Data make Linux CPU usage Become Very High, also Fix some formating  problems)

2002-08-31 15:24 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/rdd/dbf1.c
    ! Fixed hb_dbfLockRecord() to return success when area alread has file lock.

2002-08-30 11:20 UTC-0300 Luiz Rafael Culik <culikr@uol.com.br>
  * source/rtl/tget.prg
    ! fix for DeleteAll() method when Variable is Date type Reported by Charles Kwon
  * utils/hbmake/hbmake.prg
    ! fix for path when generating /etc/harbour.cfg on linux
  % source/rtl/dbdelim.prg
    ! Sync with the follow change on harbour
      2002-08-30 18:05 UTC-0400 David G. Holm <dholm@jsd-llc.com>
      * source/rtl/dbdelim.prg

2002-08-31 07:03 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/compiler/harbour.sly
    ! Fixed typo from last change.

2002-08-30 18:28 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/compiler/harbour.sly
    % Optimized WHILE .T. loops

  * source/vm/hvm.c
    % Minor optimization of HB_P_*ADDINT

  * tests/pp.prg
    * Minor correction to Auto Scrollong in DOT Mode.

2002-08-29 23:34 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * tests/pp.prg
    ! Fixed CompileNestedBlock() so that blocks withing literal arrays will not be missed.
    ! Fixed Keyboard History to not error when the buffer is full (and shift oldest command out).
    + Added auto scrolling within the DOT prompt.

  * tests/rp_dot.ch
    + Added rule for Clipper to fix bug with @ ... GET ...
    * Changed CLS to respect additional status line (1)

  /* Thanks vic@guerra.com.mx for his extensive input, and reporting of the problems leading to the above fixes.

2002-08-29 11:08 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * tests/pp.prg
    ! Fixed handling of command line defines.

  * tests/pptest.prg
    + Added #ifdef sample in demo script.

2002-08-28 14:28 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/vm/memvars.c
    ! Fixed hb_memvarSave to save date vars as date.

2002-08-27 21:30 UTC-0300 Luiz Rafael Culik <culikr@uol.com.br>
   * source/rtl/achoice.prg
     * Small fix to previus change
   * source/rtl/dummy.prg
     * removed __dbtotal() function
  + source/rdd/dbtotal.prg
     * Source file to __dbtotal() function
  * makefile.bc
    makefile.vc
    source/rdd/Makefile
     * Added dbtotal.prg to dependencie list

2002-08-27 17:15 UTC-0300 Horacio Roldan <harbour_ar@yahoo.com.ar>
   * include/fileio.ch
   * source/rtl/filesys.c
   * source/rtl/fstemp.c
     + added FO_EXCL for exclusive create
     + added convert_create_flags_ex
     ! fixed hb_fsCreateEx(), HB_FCREATE(),
       hb_fsCreateTemp(), HB_FTEMPCREATE().
       These functions were not working.

2002-08-27 10:54 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/pp/ppcore.c
    ! Fixed SernRep() so that repeated optional groups are instanciated only when given marker
      has more values than already instanciated.
    * Reinstated previous fix to TestOptional() until I learn what specific case is broken as a result.

2002-08-25 17:40 UTC-0300 Luiz Rafael Culik <culikr@uol.com.br>
  * source/common/hbffind.c
    * fixed an problem on hb_fsFindFirst() and hb_fsFindNext() apis (Windows Section)
      that was making an Directory('*.*') return less files then the total amount that
      has on that directory.

2002-08-25 21:15 UTC+0100 Marek Paliwoda <paliwoda@inetia.pl>
  * source/rtl/tbrowse.prg
    * Fixed cell formatting of string and numeric values

2002-08-23 18:46 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/vm/arrays.c
  * source/vm/hvm.c
    + Added some trace info.

  * source/vm/fastitem.c
    ! Fixed possible GPF resulting from double release of same array value.

  * source/vm/garbage.c
    ! Fixed possible GPF when attempting to refernce items of empty array.

  * tests/pp.prg
    ! Fixed reporting of line no of a script R/T error.

  * tests/pptest.prg
    * Commented out lines intended to generate R/T error, and replaced with display of Out-ofScope Var type.

  * tests/rp_run.ch
    * Moved new DO <proc> [WITH...] rules above DO CASE rule.

2002-08-23 16:24 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * tests/rp_run.ch
    + Added 2 rules to support DO <proc> [WITH ...]

  * tests/pp.prg
    ! Few minor fixes in MatchRule() to correct few reported bugs with:
      @ <r>, <c> ...
      COPY ... TO ...
    + Added status line in DOT mode.
    + Added command history support in DOT mode.

2002-08-21 12:14 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * tests/pp.prg
    * Minor modifications to fix compilation under Clipper.

2002-08-15 17:40 UTC-0300 Luiz Rafael Culik <culikr@uol.com.br>
  * source/rtl/memoedit.prg
    * When User function is Defined , Make ALT+W key exit the Editing windows if not redefined inside the UDF function

2002-08-14 21:46 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * contrib/rdd_ads/make_b32.bat
  * contrib/rdd_ads/makefile.bc
    * Reverted from Harbour
      /* Luiz, I'm amazed just how uncareful you can be, when posting to CVS! */

  * source/vm/hvm.c
    ! Minor fix to hb_vmPlus() and hb_vmMinus().

2002-08-14 15:56 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/compiler/harbour.slx
    + Added <LITERAL> as a valid prefix to a <STEP>

2002-08-14 15:52 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/compiler/harbour.slx
    + Added <LITERAL> as a valid prefix to a <TO>

2002-08-14 14:55 UTC-0300 Horacio Roldan <harbour_ar@yahoo.com.ar>
   * source/rdd/dbfcdx/dbfcdx1.c
     ! fixed some warnings

2002-08-13 18:14 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/vm/hvm.c
    ! Fixed hb_vmInc() hb_vmDec() hb_vmPlus() and hb_vmMinus() support for String[] plus/minus numeric.

2002-08-12 23:25 UTC-0300 Horacio Roldan <harbour_ar@yahoo.com.ar>
   * source/rdd/dbfcdx/dbfcdx1.c
     ! fixed seek bug when having an empty scope
     ! Memo Limit is > 64K now up to 2GB (2^31 or max(long))
     ! fixed bug in ordNumber()

2002-08-11 20:20 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/vm/hvm.c
    ! Fixed typo in hb_vmDec() which broke DATE--.

2002-08-10 22:00 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/pp/ppcore.c
    + Added support for #un[x]command and #un[x]translate
    /* In order for the #command or #translate to be removed, it has to exactly matched with the #un* definition! */

2002-08-10 21:02 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/vm/hvm.c
    ! Fixed hb_vmInc() and hb_vmDec() support of DATE++ and DATE--.

2002-08-09 14:50 UTC-0300 Luiz Rafael Culik <culikr@uol.com.br>
  * source/rtl/achoice.prg
    % Fixed Bug when nRight parameters is 79. When column 79 is used ,ie:achoice(00,00,24,79,aPesquisa), browsing an
     large array back make the display slower Reported by an Brazilian user

2002-08-09 09:48 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * include/hbapi.h
    + Added HB_IS_NUMBER() only matches numbers vs. HB_IS_NUMERIC() which also matches HB_IT_DATE and HB_IT_STRING[].

  * source/vm/hvm.c
    ! Fixed hb_vmPlus() to correctly return date when one of the operands is a DATE and the other is a NUMBER.
    ! Fixed hb_vmPlus() to correctly return date when one of the operands is a DATE and the other is a DATE (like Clipper).
    ! Fixed hb_vmMinus() to correctly return date when the left operand is a DATE and the right operand is a NUMBER.

  * include/hbexprb.c
    + Added HB_P_ADDINT optimization to HB_P_MINUS
      /* Minus operations involving an integer will now be many times faster. */

  * source/rtl/win32ole.prg
  * tests/testole.prg
    * Renamed GetObject() to GetActiveObject() to avoid conflict with WINAPI GetObject()

2002-08-09 01:25 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/rtl/win32ole.prg
    ! Finished implementation of GetObject()

  * tests/testole.prg
    * Modified demo to demonstrate usage of GetObject()

2002-08-08 12:30 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * include/hbapi.h
    * Modified HB_IS_NUMERIC() to accept HB_IT_DATE and HB_IT_STRING (length 1).

  * source/vm/hvm.c
    - Removed no longer needed hb_vmPopDate().
    + Added support for HB_IT_DATE and HB_IT_STRING[] in hb_vmPopNumber() and hb_vmPopDouble().
    - Removed explicit logic supporting DATE and STRING[] from math and comparisons opertations.
    * Completed support for DATE and STRING[] in ?all? numeric contexts.

  * source/vm/itemapi.c
    + Added support for HB_IT_STRING and HB_IT_DATE in hb_itemGetN*()

  * source/rdd/dbf1.c
  * source/rtl/minmax.c
  * source/rtl/transfrm.c
  * source/vm/arrays.c
    * Changed order of type checking so HB_IS_DATE() and HB_IS_STRING() precede HB_IS_NUMERIC() because DATE and STRING may also be NUMERIC.

  /*
     HBTEST "errors" increased by 2 (to 107 in BCC 5.5), but that only because of
     Clipper not correctly supporting DATE types in Max() and Min().
     These are NOT errors but actually the correct behaviour.
  */

2002-08-08 00:40 UTC-0300 Horacio Roldan <harbour_ar@yahoo.com.ar>
   * source/rdd/dbcmd.c
   * source/rdd/dbf1.c
     ! minor change to previous fix in dbCloseArea

2002-08-07 21:00 UTC-0300 Luiz Rafael Culik <culikr@uol.com.br>
   * utils/hbmake/hbmake.prg
     % fixed minor problems reported by users

2002-08-07 17:58 UTC-0300 Horacio Roldan <harbour_ar@yahoo.com.ar>
   * include/hbapirdd.h
   * source/rdd/dbcmd.c
   * source/rdd/workarea.c
     ! fixed gpf in dbCloseArea, now relations are
       closed if child area is closed, reported by Brian Hays

2002-08-07 16:20 UTC-0300 Horacio Roldan <harbour_ar@yahoo.com.ar>
   * source/rdd/dbf1.c
     ! added os error code, for neterr() support
       and temporary fix for Win/DOS platforms.

2002-08-06 19:45 UTC+0100 Marek Paliwoda <paliwoda@inetia.pl>
  * source/rtl/gtsln/gtsln.c
    * Fixed screen flushing when cursor is off-screen

2002-08-05 23:38 UTC-0300 Horacio Roldan <harbour_ar@yahoo.com.ar>

   * source/rdd/dbcmd.c
        ! fix GPF in dbCloseAll, reported by Jorge Mason

2002-08-05 11:03 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/rtl/cstruct.prg
    * Minor trace info.
  * source/vm/arrayshb.c
    ! Fixed type in HB_FUNC( HB_SIZEOFCSTRUCTURE ) which caused the alingment to always be 4, regardless of passed paramater.
    ! Fixed few compiler warnings regarding using NULL as a 0.

  * source/rtl/win32ole.prg
  * tests/testole.prg
    + Added work in progress implementation of GetObject()

2002-08-02 19:30 UTC-0300 Luiz Rafael Culik <culikr@uol.com.br>
  *source/rtl/set.c
    Sync with harbour with follow change
      2002-08-02 12:05 UTC-0400 David G. Holm <dholm@jsd-llc.com>
        * source/rtl/set.c
         ! When encountering SET ALTERNATE TO, close the file.
         ! When encountering SET(_SET_EXTRAFILE,NIL), close the file.

2002-07-30 11:06 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/vm/classes.c
    * Reverted "Multplication Method" to "Division Method" due to amplification of tendancy in MsgToNum()
    * More reasonable initial allocation for inherted classes too.

  * source/vm/arrayshb.c
    + Added <lAdopt> optional 4th parameter to HB_StructureToArray() indicating wether memory pointed to
      by nested pointers should be adopted by the created members. Default is .F.
    + Added <bAdopt> optional 4th parameter to StructureToArray() indicating wether memory pointed to
      by nested pointers should be adopted by the created members. Default is FALSE.

  * source/rtl/cstruct.prg
    + Added <lAdopt> optional 2nd. parameter to :Buffer() Method, indicating wether memory pointed to
      by nested pointers should be adopted by the created members. Default is .F.
    + Added <lAdopt> optional parameter to :DeValue() Method, indicating wether memory pointed to
      by nested pointers should be adopted by the created members. Default is .F.
    + Added <lAdopt> optional 2nd. parameter to :Pointer() Method, indicating wether memory pointed to
      by nested pointers should be adopted by the created members. Default is .F.

  * tests/tstcstru.prg
    * Added .T. as 2nd. parameter to Buffer() method call to demonstrate how to adopt the memory allocated from C.

  * doc/cstruct.txt
    * Updated documentation.

  * source/vm/fm.c
    * Minor modification to error message.

2002-07-29 23:58 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/rtl/cstruct.prg
    * Minor modification of Array Structure member names.

  * source/vm/classes.c
    * Changed __ClsNew() to receive additional 3rd parameter indicating the Number of additional messages (other than datas)
      pushing subsequent optional Parent to be 4th paramater.
    * __ClsNew() will now pre allocate a more reasonable initial size to ->pMethods based on class definition.
    - Removed hb_cls_MsgToNum()
    * Modified hb_cls_MsgToNum() calls to MsgToNum()
    * Modified MsgToNum() to use "Multiplication Method" instead of "Division Method" as per suggestion in
      "Mastering Algorithms with C" Pg. 145 - This produces a more consistent distribution over a table of NON prime size.
    * Reverted doubling size logic in recent change to hb_clsDictRealloc().

  * source/rtl/tclass.prg
    + Added 3rd paramater to __ClsNew() calls.

  /* J.F., can you please review these changes... */

2002-07-29 10:34 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/vm/classes.c
    * Imporoved hb_clsDictRealloc() allocation logic.

2002-07-27 16:10 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/vm/arrayshb.c
    + Added support for NIL to be compatible with ALL C TYPES.

  * source/rtl/cstruct.prg
    + Added logic to raise an error in HB_CStructureCSyntax() if member type is undefined.

  * tests/wintypes.ch
    + Added LPSTR and HBITMAP

2002-07-26 02:31 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/vm/hvm.c
    * Minor optimization in hb_vmFuncPtr()

2002-07-25 11:18 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/common/expropt1.c
    ! Fixed memory leak in optimization of empty array.

2002-07-24 11:40 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * doc/cstruct.txt
  * include/cstruct.ch
    * Added: IMPORT C STRUCTURE <strucName>. This allows usage of structures from a separately compiled modules.

2002-07-25 11:45 UTC-0300 Walter Negro <anegro@overnet.com.ar>
  * source/rtl/transfrm.c
    ! Fix minor bug in declaration of var.

    Reported by Ron Pinkas

2002-07-23 20:21 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/vm/arrayshb.c
  * source/vm/classes.c
    ! Corrected few compiler warnings.

2002-07-23 19:56 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * include/hbapi.h
  * source/vm/dynsym.c
    * Changed hb_dynsymEval( PHB_DYNS_FUNC pFunction, void * Cargo ) to return USHORT position of last scanned symbol.
    + PHB_DYNS hb_dynsymFindFromFunction( PHB_FUNC pFunc ); /* returns a dynamic symbol for a given function pointer. */
    + PHB_DYNS hb_dynsymPos( USHORT uiPos ); /* returns a dynamic symbol from a position index. */

  * source/vm/classes.c
    + PHB_DYNS hb_clsSymbolFromFunction( PHB_ITEM pObject, PHB_FUNC pFunction )
    + HB_ObjMsgPtr( oObj, cMessage ) -> nFuncPointer

  * source/vm/hvm.c
    + HB_Exec( nFuncPointer [, oSelf] [, xParam1 ] [, xParamN ] ... )

  + tests/testexec.prg
    + New test to demonstrate HB_FuncPtr(), HB_ObjMsgPtr(), HB_Exec()

2002-07-23 11:56 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * include/hbexprb.c
    ! Fixed memory leak in macro compiler related to optimizations of SubStr(), Right(), and aTail().

2002-07-23 10:35 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/rtl/cstruct.prg
    * Improved Hb_Member() to support expressions within [], like: BYTE[ SOME_LEN + 1 ]
    + Added Method Pointer( [nNewPointer] ) -> nPointer

  * source/rtl/str.c
    + Added HB_String2Pointer( cString ) -> nPointer
    + Added HB_Pointer2String( nPointer [, nLen] ) -> cStringBuffer

2002-07-23 00:21 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * include/cstruct.ch
  * source/rtl/cstruct.prg
    % Optimized C Syntax support
    ! Fixed matching of optional tagName.

  * tests/pp.prg
    ! Minor fix to -I switch.

2002-07-23 00:30 UTC-0300 Luiz Rafael Culik <culikr@uol.com.br>
  * source/rtl/isprint.c
    ! Minor formating

2002-07-22 18:43 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/rtl/isprint.c
    ! Fixed 2 type errors reported by MSVC.

2002-07-22 18:34 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * include/hbapi.h
    - Removed #define hb_itemArrayPut(...) ...

  * include/hbapiitm.h
  * source/vm/itemapi.c
    + Restored hb_itemArrayPut(...) since some compiled 3rd party code may reference the function.

  * source/rtl/cstruct.prg
    + Added Error handling code to raise standard error on some error conditions.
    + Added logic to correctly handle duplicate definition of C Structure from a seperate module.

  * source/vm/arrayshb.c
    + Added logic to correctly automatically handle conversion from HB_IT_INTEGER, HB_IT_LONG, HB_IT_DOUBLE to sign/unsigned short, int, long [*].

2002-07-18 08:00 UTC-0300 Luiz Rafael Culik <culikr@uol.com.br>
   * source/rdd/dbf1.c
    ! sync with harbour with follow change
      2002-06-07 13:53 UTC+0300 Alexander Kresin <alex@belacy.belgorod.su>
        * source/rdd/dbf1.c
        ! Bug fixed in hb_dbfLockRecord(), reported by Richard Chidiak

2002-07-17 08:50 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/rtl/idle.c
    + Added missing hb_itemRelease() based on suggestion from Niko Mikkila.
  * tests/testidle.prg
    * Minor revisions

2002-07-17 08:06 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/pp/ppcore.c
    ! Minor fix to NextName() to skip over .T. and .F.
  * source/rtl/win32ole.prg
    ! Minor fix when a type VT_DISPATCH is actually NULL.
    ! Minor fix when converted string (ansi/wide is empty string.

2002-07-17 09:08 UTC-0300 Walter Negro <anegro@overnet.com.ar>
  * source/rtl/tget.prg
    ! Fix initialization ::lEdit in New method.

    Bug and solution reported by Jose F. Gimenez

2002-07-14 13:30 UTC-0300 Walter Negro <anegro@overnet.com.ar>
  * doc/transfrm.txt
    + Add information about new functionalities.

  * doc/tracing.txt
    + Add information about work with DOS/WIN9x.

  * doc/en/var.txt
    + Add information about HB_ISBYREF().

  * source/rtl/tget.prg
    ! Fix and more compliant in Untransform(), PutMask() and KillFocus()
      methods.
    Reported by Andrew Wos

2002-07-13 19:50 UTC-0300 Luiz Rafael Culik <culikr@uol.com.br>
  * utils/hbmake/hbmake.prg
   ! Minor changes to Library edit mode. added option to install library on
     xharbour library directory

2002-07-11 11:29 UTC-0300 Walter Negro <anegro@overnet.com.ar>
  * source/vm/itemapi.c
    ! Fix rounded for big numbers ( more of 16 significant numbers ).

2002-07-10 23:55 UTC-0300 Luiz Rafael Culik <culikr@uol.com.br>
  + contrib/rdd_ads/*
    + All files for rdd_ads is now on xharbour repository

2002-07-10 17:12 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * include/hbexprb.c
    ! Added missing break that caused an excess call to HB_XFREE() resulting in error 9022.

2002-07-09 22:00 UTC-0300 Luiz Rafael Culik <culikr@uol.com.br>
  * utils/hbmake/hbmake.prg
   ! Fix the determination of Error when compiling C/Cpp sources

2002-07-08 01:40 UTC-0300 Walter Negro <anegro@overnet.com.ar>
  * source/rtl/tget.prg
    ! Fix minor bug in PutMask() method.

      Reported by Luiz Rafael Culik from brazilian user

2002-07-07 23:10 UTC-0300 Luiz Rafael Culik <culikr@uol.com.br>
  * utils/hbmake/hbmake.prg
    utils/hbmake/hbmutils.prg
     % compilation of .cpp files is working properly now
     % compilation of .rc files fixed
     * new option to harbour that say to use Fivehx.lib for FWH
     * Added .cpp files for user selection box

2002-07-07 14:00 UTC-0300 Walter Negro <anegro@overnet.com.ar>
  * source/rtl/transfrm.c
    ! Fix with numeric values and pictures with spaces and pictures with
      severals dot.
      The return values are compliant with Clipper.
      eg: Transform( 1234, "9 999" )
      eg: Transform( 123.123456, "999.99.99.99" )

2002-07-05 23:35 UTC-0300 Luiz Rafael Culik <culikr@uol.com.br>
  * source/rtl/isprint.c
    * Final Fix for getprinters() function to work properly on WinXP

2002-07-05 12:51 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * bin/bld.bat
    ! Reverted Luiz change of hardcoded paths with relative paths. (Luiz ??? - This wasted an hour of my time!!!)

  * source/vm/hvm.c
    ! Minor fix to hb_vmPushLocalByRef() and hb_vmPushStsticByRef()

  * source/vm/memvars.c
    ! Minor fix to hb_memvarGetRefer()

2002-07-05 12:37 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * include/hbapifs.h
    + Added missing: extern int WintoDosError( unsigned long lError)

  * include/hbsetup.h
    + Added MSVC to compilers enabling HB_OS_WIN_32

  * source/common/hbffind.c
    ! Corrected usage of WintoDosError()

2002-07-03 21:30 UTC-0300 Luiz Rafael Culik <culikr@uol.com.br>
  * source/rtl/isprint.c
    * Fixed getprinters() function to work properly on WinXP

2002-07-03 19:10 UTC-0300 Walter Negro <anegro@overnet.com.ar>
  * source/rtl/transfrm.c
    + Add @) template.

    ! Fix @D with numeric expressions.

    ! Fix bug with @D in string expressions.
      eg: Transform( "1", "@D" )
      This example generate an GPF or strange memory errors.

    ! Better support for mask with initial comma, period or space.

    ! Better support for later mask.

    ! Replace comma, period or the correspondient space with an '*'
      when previous character is '*' too.
      eg: Transform( 99999, "9.999" ) -> Before: "* ***" Now: "*****"
          Transform(    99, "*.***" ) -> Before: "* *99" Now: "***99"

    * More compliant, resolve several hbtest errors.

  * source/rtl/tgetlist.prg
    * Detection of modification with direct access to the var get in
      preval, postval and setkey functions.

      Point of control: GetPreValidate(), GetPostValidate(),
                        GUIGetPreValidate(), GUIGetPostValidate(),
                        GetDoSetKey().

  * source/rtl/tget.prg
    + Add two protected methods. FirstEditable() and LastEditable().
      Several change for use this methods.

    ! Fix in ParsePict method
      * @D function, overwrite the mask for SET DATE FORMAT
      * @S without lenght parameter or @S0, they don't have effect.

    ! Fix in Untransform method
      * if ::lEdit is false, return ::VarGet() without evaluate
        the buffer contained.
      * Better detection of a negative, minimizing false detections.
      * Improvement in the handling of mask.
      * More compliant in @D, @E, @X, @C, @(, @) functions.
      * In compliant with Clipper, the lenght of number (internal lenght)
        corresponds to the applied picture.
      ! Bug in conversion with date types and with @E function.

    ! Fix in Overstrike and Insert method
      * First it is evaluated if the input character is valid, before
        cleaning the var.

    ! Fix in Input method
      * The minus sign can be writed in any place.
      * Now work with '$' and '*' templates in numeric gets.

    ! Fix in PutMask method
      * More compliant in the handling of some get functions.
      * When edit a get with @B, the number is editing right-justified.

    ! Fix in Backspace method
      * Permit delete a '(' symbol in a non-editable position, when
        this symbol represent a negative number.

    ! Fix in Delete method
      ! When delete a negative symbol '(' or '-', turn the ::minus tu false

    ! Fix in IsBadDate function
      ! Evaluate correctly a date with @E function.

  * source/rtl/dates.c
    * More compliant for certain strange formats. eg: DD/MMM/YYYY

2002-07-02 10:20 UTC-0300 Luiz Rafael Culik <culikr@uol.com.br>
  * source/rtl/filesys.c
    source/common/hbffind.c
    ! Fixed Error values for djgpp(Djgpp error.h values is diferent from other C compilers)
  * utils/hbtest/rt_file.prg
    * Fixed the test for File( cFileName ), The file exist when this test is done, so i've correct the error value

2002-06-30 17:00 UTC-0300 Luiz Rafael Culik <culikr@uol.com.br>
  + contrib/hbzlib/*.*
    + Added all files need to build hbzlib and zlib

2002-06-29 09:55 UTC-0300 Luiz Rafael Culik <culikr@uol.com.br>
  * source/rtl/gtsln/gtsln.c
    ! Reverted back to previus version since this syncro was not needed

2002-06-29 00:02 UTC-0300 Luiz Rafael Culik <culikr@uol.com.br>
  * source/rtl/set.c
    ! Fixed Minor Bug that was preventing the use of the printer Again
    when Using  Set(24,"win:"xxx)
 * utils/hbmake/hbmake.prg
    ! Changed temporary file name from makefile.tmp makefile.lnk
  *Sync Xharbour with this last changes of Harbour(With date)
2002-06-28 10:43 UTC+0300 Alexander Kresin <alex@belacy.belgorod.su>
  * source/rdd/dbfntx/dbfntx1.c
    ! Bug fixed in hb_ntxPageSplit() - the created page was not released.

2002-06-27 15:25 UTC-0400 David G. Holm <dholm@jsd-llc.com>
  * source/rtl/gtsln/gtsln.c
    ! HRBNATIONCHARS fix provided by Niko Mikkila <nm@phnet.fi>

2002-06-27 22:30 UTC+0300 Alexander Kresin <alex@belacy.belgorod.su>
  * source/rdd/workarea.c
    ! Bug fixed in hb_waSetRel(), reported by Richard  Chidiak

2002-06-26 18:41 UTC+0100 Ignacio Ortiz <ignacio@fivetech.com>
  * source/rtl/tget.prg
    !Fixed minus property value, did not work correctly


2002-06-25 09:00 UTC-0800 Ron Pinkas <ron@ronpinkas.com>
  * source/compiler/harbour.slx
    ! Fixed handling of TEXT as IDENTIFIER.

2002-06-25 09:25 UTC-0300 Luiz Rafael Culik <culikr@uol.com.br>
  * source/rdd/dbfntx/dbfntx1.c
   * Added the xharbour Pcode signature(missed in previus post)

2002-06-24 21:25 UTC-0300 Luiz Rafael Culik <culikr@uol.com.br>
  * source/rtl/tget.prg
   source/rdd/dbcmd.c
   source/rdd/dbfntx/dbfntx1.c
    * Sync with Harbour
 * Changelog renamed to Changelog.013 and started an new one


